/* @file AVModel_modMain_container.h
 * Container Interface header for Module AVModel_modMain
 * Generated automatically from specification; do not modify here
 */

#if !defined(AVMODEL_MODMAIN_CONTAINER_H)
#define AVMODEL_MODMAIN_CONTAINER_H


/* Include the types from the XML types files */
#include "ECOA.h"

#include "AVS.h"

#include "AVModel_modMain_user_context.h"


#if defined(__cplusplus)
extern "C" {
#endif /* __cplusplus */

/* Incomplete definition of the technical (platform-dependent) part of the context
 * (it will be defined privately by the container) */
struct AVModel_modMain__platform_hook;

/* Module Context structure declaration */
typedef struct 
{
   /*
    * Other container technical data will accessible through the pointer
    * defined here
    */
   struct AVModel_modMain__platform_hook *platform_hook;

   /* the type AVModel_modMain_user_context shall be defined by the user
    * in the AVModel_modMain_user_context.h file to carry the module
    * implementation private data
    */
   AVModel_modMain_user_context user;

} AVModel_modMain__context;


/* Logging and fault management services API */
void AVModel_modMain_container__log_trace
   (AVModel_modMain__context* context, const ECOA__log log);

void AVModel_modMain_container__log_debug
   (AVModel_modMain__context* context, const ECOA__log log);

void AVModel_modMain_container__log_info
   (AVModel_modMain__context* context, const ECOA__log log);

void AVModel_modMain_container__log_warning
   (AVModel_modMain__context* context, const ECOA__log log);

void AVModel_modMain_container__raise_error
   (AVModel_modMain__context* context, const ECOA__log log);

void AVModel_modMain_container__raise_fatal_error
   (AVModel_modMain__context* context, const ECOA__log log);

/* Time services API */
void AVModel_modMain_container__get_relative_local_time
   (AVModel_modMain__context* context, ECOA__hr_time* relative_local_time);

ECOA__return_status AVModel_modMain_container__get_UTC_time
   (AVModel_modMain__context* context, ECOA__global_time* utc_time);

ECOA__return_status AVModel_modMain_container__get_absolute_system_time
   (AVModel_modMain__context* context, ECOA__global_time* absolute_system_time);

/* Time resolution services API */
void AVModel_modMain_container__get_relative_local_time_resolution
   (AVModel_modMain__context* context, ECOA__duration* relative_local_time_resolution);

void AVModel_modMain_container__get_UTC_time_resolution
   (AVModel_modMain__context* context, ECOA__duration* utc_time_resolution);

void AVModel_modMain_container__get_absolute_system_time_resolution
   (AVModel_modMain__context* context, ECOA__duration* absolute_system_time_resolution);

void AVModel_modMain_container__AVSUpdate__send
   (AVModel_modMain__context* context,
    const AVS__AVS* avs);


#if defined(__cplusplus)
}
#endif /* __cplusplus */

#endif  /* AVMODEL_MODMAIN_CONTAINER_H */

