/* File AVModel_modMain_user_context.h */
/*
 ##############################################################
 # (C) 2015 BAE SYSTEMS
 #
 # ECOA Data Servers Sample - Aircraft Model
 #
 # $Id: AVModel_modMain_user_context.h,v 2.1 2017/11/06 15:33:32 ksappleb Exp $
 #
 # Part of the BAE Systems, Rochester, ECOA Samples collection
 #
 # Created by K S Appleby, BAE Systems, Airport Works, Rochester, Kent
 #
 # This software is developed for and on behalf of BAE Systems (Operations)
 # Limited, Dassault Aviation, Bull SAS, Thales Systemes Aeroportes,
 # GE Aviation Systems Limited,
 # General Dynamics United Kingdom Limited and Leonardo MW Ltd,
 # and the copyright is owned by BAE Systems (Operations) Limited,
 # Dassault Aviation, Bull SAS, Thales Systemes Aeroportes, 
 # GE Aviation Systems Limited, General Dynamics United Kingdom
 # Limited and Leonardo MW Ltd
 #
 # This software is developed by BAE Systems (Operations)
 # Limited, Electronic Systems, and is the Intellectual
 # Property of BAE Systems (Operations) Limited, Electronic Systems.
 #
 # The information set out in this document is provided solely
 # on an 'as is' basis and the co-developers of this software make
 # no warranties expressed or implied, including no warranties
 # as to completeness, accuracy or fitness for purpose, with respect
 # to any of the information.
 ##############################################################
*/
#if !defined(_AVMODEL_MODMAIN_USER_CONTEXT_H)
#define _AVMODEL_MODMAIN_USER_CONTEXT_H

#include <AVS.h>

#if defined(__cplusplus)
extern "C" {
#endif /* __cplusplus */

/* Container Types */
#include "AVModel_modMain_container_types.h"

/* User Module Context structure example */
typedef struct
{
   /* declare the User Module Context "local" data here */
	ECOA__double64 Latitude;
	ECOA__double64 Longitude;
	ECOA__double64 Height;
	ECOA__double64 Speed;
	ECOA__double64 Heading;

} AVModel_modMain_user_context;

/* Warm Start Module Context structure example */
typedef struct
{
   /* declare the Warm Start Module Context data here */
   int dmy;
} AVModel_modMain_warm_start_context;

#if defined(__cplusplus)
}
#endif /* __cplusplus */

#endif  /* _AVMODEL_MODMAIN_USER_CONTEXT_H */
