/* @file HUMS_modMain_container.h
 * Container Interface header for Module HUMS_modMain
 * Generated automatically from specification; do not modify here
 */

#if !defined(HUMS_MODMAIN_CONTAINER_H)
#define HUMS_MODMAIN_CONTAINER_H


/* Include the types from the XML types files */
#include "ECOA.h"

#include "ECOA__DBM.h"

#include "ECOA__SQL.h"

#include "AVS.h"

#include "HUMS_modMain_user_context.h"


#if defined(__cplusplus)
extern "C" {
#endif /* __cplusplus */

/* Incomplete definition of the technical (platform-dependent) part of the context
 * (it will be defined privately by the container) */
struct HUMS_modMain__platform_hook;

/* Module Context structure declaration */
typedef struct 
{
   /*
    * Other container technical data will accessible through the pointer
    * defined here
    */
   struct HUMS_modMain__platform_hook *platform_hook;

   /* the type HUMS_modMain_user_context shall be defined by the user
    * in the HUMS_modMain_user_context.h file to carry the module
    * implementation private data
    */
   HUMS_modMain_user_context user;

} HUMS_modMain__context;


/* Logging and fault management services API */
void HUMS_modMain_container__log_trace
   (HUMS_modMain__context* context, const ECOA__log log);

void HUMS_modMain_container__log_debug
   (HUMS_modMain__context* context, const ECOA__log log);

void HUMS_modMain_container__log_info
   (HUMS_modMain__context* context, const ECOA__log log);

void HUMS_modMain_container__log_warning
   (HUMS_modMain__context* context, const ECOA__log log);

void HUMS_modMain_container__raise_error
   (HUMS_modMain__context* context, const ECOA__log log);

void HUMS_modMain_container__raise_fatal_error
   (HUMS_modMain__context* context, const ECOA__log log);

/* Time services API */
void HUMS_modMain_container__get_relative_local_time
   (HUMS_modMain__context* context, ECOA__hr_time* relative_local_time);

ECOA__return_status HUMS_modMain_container__get_UTC_time
   (HUMS_modMain__context* context, ECOA__global_time* utc_time);

ECOA__return_status HUMS_modMain_container__get_absolute_system_time
   (HUMS_modMain__context* context, ECOA__global_time* absolute_system_time);

/* Time resolution services API */
void HUMS_modMain_container__get_relative_local_time_resolution
   (HUMS_modMain__context* context, ECOA__duration* relative_local_time_resolution);

void HUMS_modMain_container__get_UTC_time_resolution
   (HUMS_modMain__context* context, ECOA__duration* utc_time_resolution);

void HUMS_modMain_container__get_absolute_system_time_resolution
   (HUMS_modMain__context* context, ECOA__duration* absolute_system_time_resolution);

void HUMS_modMain_container__get_CIMSDB_value
   (HUMS_modMain__context* context,
    ECOA__SQL__StringZ* value);

void HUMS_modMain_container__get_UserName_value
   (HUMS_modMain__context* context,
    ECOA__SQL__StringZ* value);

void HUMS_modMain_container__get_Password_value
   (HUMS_modMain__context* context,
    ECOA__SQL__StringZ* value);

ECOA__return_status HUMS_modMain_container__open__request_sync
   (HUMS_modMain__context* context,
    const ECOA__DBM__String* name,
    const ECOA__int32 size,
    const ECOA__DBM__OpenFlags flags,
    const ECOA__DBM__Permissions* mode,
    ECOA__DBM__ConnectionId* connection,
    ECOA__int32* dbmStatus);

ECOA__return_status HUMS_modMain_container__close__request_sync
   (HUMS_modMain__context* context,
    const ECOA__DBM__ConnectionId connection);

ECOA__return_status HUMS_modMain_container__store__request_sync
   (HUMS_modMain__context* context,
    const ECOA__DBM__ConnectionId connection,
    const ECOA__DBM__Datum* key,
    const ECOA__DBM__Datum* content,
    const ECOA__DBM__StoreFlag flag,
    ECOA__int32* dbmStatus);

ECOA__return_status HUMS_modMain_container__fetch__request_sync
   (HUMS_modMain__context* context,
    const ECOA__DBM__ConnectionId connection,
    const ECOA__DBM__Datum* key,
    ECOA__DBM__Datum* content,
    ECOA__int32* dbmStatus);

ECOA__return_status HUMS_modMain_container__exists__request_sync
   (HUMS_modMain__context* context,
    const ECOA__DBM__ConnectionId connection,
    const ECOA__DBM__Datum* key,
    ECOA__boolean8* exists);

ECOA__return_status HUMS_modMain_container__delete__request_sync
   (HUMS_modMain__context* context,
    const ECOA__DBM__ConnectionId connection,
    const ECOA__DBM__Datum* key,
    ECOA__int32* dbmStatus);

ECOA__return_status HUMS_modMain_container__firstkey__request_sync
   (HUMS_modMain__context* context,
    const ECOA__DBM__ConnectionId connection,
    ECOA__DBM__Datum* key,
    ECOA__int32* dbmStatus);

ECOA__return_status HUMS_modMain_container__nexttkey__request_sync
   (HUMS_modMain__context* context,
    const ECOA__DBM__ConnectionId connection,
    const ECOA__DBM__Datum* key,
    ECOA__DBM__Datum* nextkey,
    ECOA__int32* dbmStatus);

ECOA__return_status HUMS_modMain_container__reorganize__request_sync
   (HUMS_modMain__context* context,
    const ECOA__DBM__ConnectionId connection,
    ECOA__int32* dbmStatus);

ECOA__return_status HUMS_modMain_container__sync__request_sync
   (HUMS_modMain__context* context,
    const ECOA__DBM__ConnectionId connection,
    ECOA__int32* dbmStatus);

ECOA__return_status HUMS_modMain_container__lasterror__request_sync
   (HUMS_modMain__context* context,
    ECOA__int32* errnum,
    ECOA__DBM__String* errtxt);

ECOA__return_status HUMS_modMain_container__setopt__request_sync
   (HUMS_modMain__context* context,
    const ECOA__DBM__ConnectionId connection,
    const ECOA__DBM__Option option,
    const ECOA__int32 value,
    ECOA__int32* dbmStatus);

ECOA__return_status HUMS_modMain_container__dbm_dump__request_sync
   (HUMS_modMain__context* context,
    const ECOA__DBM__ConnectionId connection,
    const ECOA__DBM__String* fileName,
    ECOA__int32* dbmStatus);

ECOA__return_status HUMS_modMain_container__dbm_take__request_sync
   (HUMS_modMain__context* context,
    const ECOA__DBM__ConnectionId connection,
    const ECOA__DBM__String* fileName,
    ECOA__int32* dbmStatus);

ECOA__return_status HUMS_modMain_container__dbm_getHelp__request_sync
   (HUMS_modMain__context* context,
    const ECOA__DBM__ConnectionId connection,
    ECOA__DBM__String* help,
    ECOA__int32* dbmStatus);

ECOA__return_status HUMS_modMain_container__dbm_getLimits__request_sync
   (HUMS_modMain__context* context,
    const ECOA__DBM__ConnectionId connection,
    ECOA__char8* limits,
    ECOA__int32* dbmStatus);

ECOA__return_status HUMS_modMain_container__dbm_getCounts__request_sync
   (HUMS_modMain__context* context,
    const ECOA__DBM__ConnectionId connection,
    ECOA__char8* counts,
    ECOA__int32* dbmStatus);

ECOA__return_status HUMS_modMain_container__getConnection__request_async
   (HUMS_modMain__context* context,
    ECOA__uint32* ID,
    const ECOA__SQL__String* dataSource,
    const ECOA__SQL__NameString* userName,
    const ECOA__SQL__NameString* password);

ECOA__return_status HUMS_modMain_container__endConnection__request_sync
   (HUMS_modMain__context* context,
    const ECOA__SQL__ConnectionId connection,
    ECOA__SQL__Error* requestStatus);

ECOA__return_status HUMS_modMain_container__SQLExecute__request_sync
   (HUMS_modMain__context* context,
    const ECOA__SQL__ConnectionId connection,
    const ECOA__SQL__String* SQLString,
    ECOA__SQL__ResultSetId* transaction);

ECOA__return_status HUMS_modMain_container__getResult__request_sync
   (HUMS_modMain__context* context,
    const ECOA__SQL__ConnectionId connection,
    const ECOA__SQL__ResultSetId transaction,
    const ECOA__SQL__ScrollSet* scroll,
    ECOA__SQL__Error* requestStatus);

ECOA__return_status HUMS_modMain_container__getResultData__request_sync
   (HUMS_modMain__context* context,
    const ECOA__SQL__ConnectionId connection,
    const ECOA__SQL__ResultSetId transaction,
    const ECOA__uint16 columnNo,
    ECOA__SQL__ColumnValue* columnValue,
    ECOA__SQL__Error* requestStatus);

ECOA__return_status HUMS_modMain_container__getResultColumnCount__request_sync
   (HUMS_modMain__context* context,
    const ECOA__SQL__ConnectionId connection,
    const ECOA__SQL__ResultSetId transaction,
    ECOA__uint16* columnCount,
    ECOA__SQL__Error* requestStatus);

ECOA__return_status HUMS_modMain_container__getResultColumnInfo__request_sync
   (HUMS_modMain__context* context,
    const ECOA__SQL__ConnectionId connection,
    const ECOA__SQL__ResultSetId transaction,
    const ECOA__uint16 columnNo,
    ECOA__SQL__ColumnInfo* columnInfo,
    ECOA__SQL__Error* requestStatus);

ECOA__return_status HUMS_modMain_container__getStatus__request_sync
   (HUMS_modMain__context* context,
    const ECOA__SQL__ConnectionId connection,
    const ECOA__SQL__ResultSetId transaction,
    const ECOA__int16 recordNo,
    ECOA__SQL__ResultStatus* resultStatus,
    ECOA__SQL__Error* requestStatus);

ECOA__return_status HUMS_modMain_container__setUpdateTable__request_sync
   (HUMS_modMain__context* context,
    const ECOA__SQL__ConnectionId connection,
    const ECOA__SQL__NameString* tableName,
    ECOA__SQL__Error* requestStatus);

ECOA__return_status HUMS_modMain_container__dump__request_sync
   (HUMS_modMain__context* context,
    const ECOA__SQL__ConnectionId connection,
    const ECOA__SQL__String* fileName,
    const ECOA__SQL__FileType format,
    ECOA__SQL__Error* requestStatus);

ECOA__return_status HUMS_modMain_container__take__request_sync
   (HUMS_modMain__context* context,
    const ECOA__SQL__ConnectionId connection,
    const ECOA__SQL__String* fileName,
    const ECOA__SQL__FileType format,
    ECOA__SQL__Error* requestStatus);

ECOA__return_status HUMS_modMain_container__getHelp__request_sync
   (HUMS_modMain__context* context,
    const ECOA__SQL__ConnectionId connection,
    ECOA__SQL__String* help,
    ECOA__SQL__Error* requestStatus);

ECOA__return_status HUMS_modMain_container__listTables__request_sync
   (HUMS_modMain__context* context,
    const ECOA__SQL__ConnectionId connection,
    ECOA__SQL__TableNameList* tableList,
    ECOA__SQL__Error* requestStatus);

ECOA__return_status HUMS_modMain_container__getLimits__request_sync
   (HUMS_modMain__context* context,
    const ECOA__SQL__ConnectionId connection,
    ECOA__SQL__IntegerList* limits,
    ECOA__SQL__Error* requestStatus);

ECOA__return_status HUMS_modMain_container__getCounts__request_sync
   (HUMS_modMain__context* context,
    const ECOA__SQL__ConnectionId connection,
    ECOA__SQL__IntegerList* counts,
    ECOA__SQL__Error* requestStatus);

ECOA__return_status HUMS_modMain_container__getErrorText__request_sync
   (HUMS_modMain__context* context,
    const ECOA__SQL__Error requestStatus,
    ECOA__SQL__String* statusText);


#if defined(__cplusplus)
}
#endif /* __cplusplus */

#endif  /* HUMS_MODMAIN_CONTAINER_H */

