/* @file MissionSys_modANOther_container.h
 * Container Interface header for Module MissionSys_modANOther
 * Generated automatically from specification; do not modify here
 */

#if !defined(MISSIONSYS_MODANOTHER_CONTAINER_H)
#define MISSIONSYS_MODANOTHER_CONTAINER_H


/* Include the types from the XML types files */
#include "ECOA.h"

#include "ECOA__DBM.h"

#include "ECOA__SQL.h"

#include "AVS.h"

#include "MissionSys_modANOther_user_context.h"


#if defined(__cplusplus)
extern "C" {
#endif /* __cplusplus */

/* Incomplete definition of the technical (platform-dependent) part of the context
 * (it will be defined privately by the container) */
struct MissionSys_modANOther__platform_hook;

/* Module Context structure declaration */
typedef struct 
{
   /*
    * Other container technical data will accessible through the pointer
    * defined here
    */
   struct MissionSys_modANOther__platform_hook *platform_hook;

   /* the type MissionSys_modANOther_user_context shall be defined by the user
    * in the MissionSys_modANOther_user_context.h file to carry the module
    * implementation private data
    */
   MissionSys_modANOther_user_context user;

} MissionSys_modANOther__context;


/* Logging and fault management services API */
void MissionSys_modANOther_container__log_trace
   (MissionSys_modANOther__context* context, const ECOA__log log);

void MissionSys_modANOther_container__log_debug
   (MissionSys_modANOther__context* context, const ECOA__log log);

void MissionSys_modANOther_container__log_info
   (MissionSys_modANOther__context* context, const ECOA__log log);

void MissionSys_modANOther_container__log_warning
   (MissionSys_modANOther__context* context, const ECOA__log log);

void MissionSys_modANOther_container__raise_error
   (MissionSys_modANOther__context* context, const ECOA__log log);

void MissionSys_modANOther_container__raise_fatal_error
   (MissionSys_modANOther__context* context, const ECOA__log log);

/* Time services API */
void MissionSys_modANOther_container__get_relative_local_time
   (MissionSys_modANOther__context* context, ECOA__hr_time* relative_local_time);

ECOA__return_status MissionSys_modANOther_container__get_UTC_time
   (MissionSys_modANOther__context* context, ECOA__global_time* utc_time);

ECOA__return_status MissionSys_modANOther_container__get_absolute_system_time
   (MissionSys_modANOther__context* context, ECOA__global_time* absolute_system_time);

/* Time resolution services API */
void MissionSys_modANOther_container__get_relative_local_time_resolution
   (MissionSys_modANOther__context* context, ECOA__duration* relative_local_time_resolution);

void MissionSys_modANOther_container__get_UTC_time_resolution
   (MissionSys_modANOther__context* context, ECOA__duration* utc_time_resolution);

void MissionSys_modANOther_container__get_absolute_system_time_resolution
   (MissionSys_modANOther__context* context, ECOA__duration* absolute_system_time_resolution);

ECOA__return_status MissionSys_modANOther_container__open_remdbm__request_sync
   (MissionSys_modANOther__context* context,
    const ECOA__DBM__String* database,
    const ECOA__int32 size,
    const ECOA__DBM__OpenFlags flags,
    const ECOA__DBM__Permissions* mode,
    ECOA__DBM__ConnectionId* connection,
    ECOA__int32* dbmStatus);

ECOA__return_status MissionSys_modANOther_container__close_remdbm__request_sync
   (MissionSys_modANOther__context* context,
    const ECOA__DBM__ConnectionId connection);

ECOA__return_status MissionSys_modANOther_container__store_remdbm__request_sync
   (MissionSys_modANOther__context* context,
    const ECOA__DBM__ConnectionId connection,
    const ECOA__DBM__Datum* key,
    const ECOA__DBM__Datum* content,
    const ECOA__DBM__StoreFlag flag,
    ECOA__int32* dbmStatus);

ECOA__return_status MissionSys_modANOther_container__fetch_remdbm__request_sync
   (MissionSys_modANOther__context* context,
    const ECOA__DBM__ConnectionId connection,
    const ECOA__DBM__Datum* key,
    ECOA__DBM__Datum* content,
    ECOA__int32* dbmStatus);

ECOA__return_status MissionSys_modANOther_container__exists_remdbm__request_sync
   (MissionSys_modANOther__context* context,
    const ECOA__DBM__ConnectionId connection,
    const ECOA__DBM__Datum* key,
    ECOA__boolean8* exists);

ECOA__return_status MissionSys_modANOther_container__delete_remdbm__request_sync
   (MissionSys_modANOther__context* context,
    const ECOA__DBM__ConnectionId connection,
    const ECOA__DBM__Datum* key,
    ECOA__int32* dbmStatus);

ECOA__return_status MissionSys_modANOther_container__firstkey_remdbm__request_sync
   (MissionSys_modANOther__context* context,
    const ECOA__DBM__ConnectionId connection,
    ECOA__DBM__Datum* key,
    ECOA__int32* dbmStatus);

ECOA__return_status MissionSys_modANOther_container__nexttkey_remdbm__request_sync
   (MissionSys_modANOther__context* context,
    const ECOA__DBM__ConnectionId connection,
    const ECOA__DBM__Datum* key,
    ECOA__DBM__Datum* nextkey,
    ECOA__int32* dbmStatus);

ECOA__return_status MissionSys_modANOther_container__reorganize_remdbm__request_sync
   (MissionSys_modANOther__context* context,
    const ECOA__DBM__ConnectionId connection,
    ECOA__int32* dbmStatus);

ECOA__return_status MissionSys_modANOther_container__sync_remdbm__request_sync
   (MissionSys_modANOther__context* context,
    const ECOA__DBM__ConnectionId connection,
    ECOA__int32* dbmStatus);

ECOA__return_status MissionSys_modANOther_container__lasterror_remdbm__request_sync
   (MissionSys_modANOther__context* context,
    ECOA__int32* errnum,
    ECOA__DBM__String* errtxt);

ECOA__return_status MissionSys_modANOther_container__setopt_remdbm__request_sync
   (MissionSys_modANOther__context* context,
    const ECOA__DBM__ConnectionId connection,
    const ECOA__DBM__Option option,
    const ECOA__int32 value,
    ECOA__int32* dbmStatus);

ECOA__return_status MissionSys_modANOther_container__dump_remdbm__request_sync
   (MissionSys_modANOther__context* context,
    const ECOA__DBM__ConnectionId connection,
    const ECOA__DBM__String* fileName,
    ECOA__int32* dbmStatus);

ECOA__return_status MissionSys_modANOther_container__take_remdbm__request_sync
   (MissionSys_modANOther__context* context,
    const ECOA__DBM__ConnectionId connection,
    const ECOA__DBM__String* fileName,
    ECOA__int32* dbmStatus);

ECOA__return_status MissionSys_modANOther_container__getHelp_remdbm__request_sync
   (MissionSys_modANOther__context* context,
    const ECOA__DBM__ConnectionId connection,
    ECOA__DBM__String* help,
    ECOA__int32* dbmStatus);

ECOA__return_status MissionSys_modANOther_container__getLimits_remdbm__request_sync
   (MissionSys_modANOther__context* context,
    const ECOA__DBM__ConnectionId connection,
    ECOA__char8* limits,
    ECOA__int32* dbmStatus);

ECOA__return_status MissionSys_modANOther_container__getCounts_remdbm__request_sync
   (MissionSys_modANOther__context* context,
    const ECOA__DBM__ConnectionId connection,
    ECOA__char8* counts,
    ECOA__int32* dbmStatus);

ECOA__return_status MissionSys_modANOther_container__open_lcldbm__request_sync
   (MissionSys_modANOther__context* context,
    const ECOA__DBM__String* database,
    const ECOA__int32 size,
    const ECOA__DBM__OpenFlags flags,
    const ECOA__DBM__Permissions* mode,
    ECOA__DBM__ConnectionId* connection,
    ECOA__int32* dbmStatus);

ECOA__return_status MissionSys_modANOther_container__close_lcldbm__request_sync
   (MissionSys_modANOther__context* context,
    const ECOA__DBM__ConnectionId connection);

ECOA__return_status MissionSys_modANOther_container__store_lcldbm__request_sync
   (MissionSys_modANOther__context* context,
    const ECOA__DBM__ConnectionId connection,
    const ECOA__DBM__Datum* key,
    const ECOA__DBM__Datum* content,
    const ECOA__DBM__StoreFlag flag,
    ECOA__int32* dbmStatus);

ECOA__return_status MissionSys_modANOther_container__fetch_lcldbm__request_sync
   (MissionSys_modANOther__context* context,
    const ECOA__DBM__ConnectionId connection,
    const ECOA__DBM__Datum* key,
    ECOA__DBM__Datum* content,
    ECOA__int32* dbmStatus);

ECOA__return_status MissionSys_modANOther_container__exists_lcldbm__request_sync
   (MissionSys_modANOther__context* context,
    const ECOA__DBM__ConnectionId connection,
    const ECOA__DBM__Datum* key,
    ECOA__boolean8* exists);

ECOA__return_status MissionSys_modANOther_container__delete_lcldbm__request_sync
   (MissionSys_modANOther__context* context,
    const ECOA__DBM__ConnectionId connection,
    const ECOA__DBM__Datum* key,
    ECOA__int32* dbmStatus);

ECOA__return_status MissionSys_modANOther_container__firstkey_lcldbm__request_sync
   (MissionSys_modANOther__context* context,
    const ECOA__DBM__ConnectionId connection,
    ECOA__DBM__Datum* key,
    ECOA__int32* dbmStatus);

ECOA__return_status MissionSys_modANOther_container__nexttkey_lcldbm__request_sync
   (MissionSys_modANOther__context* context,
    const ECOA__DBM__ConnectionId connection,
    const ECOA__DBM__Datum* key,
    ECOA__DBM__Datum* nextkey,
    ECOA__int32* dbmStatus);

ECOA__return_status MissionSys_modANOther_container__reorganize_lcldbm__request_sync
   (MissionSys_modANOther__context* context,
    const ECOA__DBM__ConnectionId connection,
    ECOA__int32* dbmStatus);

ECOA__return_status MissionSys_modANOther_container__sync_lcldbm__request_sync
   (MissionSys_modANOther__context* context,
    const ECOA__DBM__ConnectionId connection,
    ECOA__int32* dbmStatus);

ECOA__return_status MissionSys_modANOther_container__lasterror_lcldbm__request_sync
   (MissionSys_modANOther__context* context,
    ECOA__int32* errnum,
    ECOA__DBM__String* errtxt);

ECOA__return_status MissionSys_modANOther_container__setopt_lcldbm__request_sync
   (MissionSys_modANOther__context* context,
    const ECOA__DBM__ConnectionId connection,
    const ECOA__DBM__Option option,
    const ECOA__int32 value,
    ECOA__int32* dbmStatus);

ECOA__return_status MissionSys_modANOther_container__dump_lcldbm__request_sync
   (MissionSys_modANOther__context* context,
    const ECOA__DBM__ConnectionId connection,
    const ECOA__DBM__String* fileName,
    ECOA__int32* dbmStatus);

ECOA__return_status MissionSys_modANOther_container__take_lcldbm__request_sync
   (MissionSys_modANOther__context* context,
    const ECOA__DBM__ConnectionId connection,
    const ECOA__DBM__String* fileName,
    ECOA__int32* dbmStatus);

ECOA__return_status MissionSys_modANOther_container__getHelp_lcldbm__request_sync
   (MissionSys_modANOther__context* context,
    const ECOA__DBM__ConnectionId connection,
    ECOA__DBM__String* help,
    ECOA__int32* dbmStatus);

ECOA__return_status MissionSys_modANOther_container__getLimits_lcldbm__request_sync
   (MissionSys_modANOther__context* context,
    const ECOA__DBM__ConnectionId connection,
    ECOA__char8* limits,
    ECOA__int32* dbmStatus);

ECOA__return_status MissionSys_modANOther_container__getCounts_lcldbm__request_sync
   (MissionSys_modANOther__context* context,
    const ECOA__DBM__ConnectionId connection,
    ECOA__char8* counts,
    ECOA__int32* dbmStatus);


#if defined(__cplusplus)
}
#endif /* __cplusplus */

#endif  /* MISSIONSYS_MODANOTHER_CONTAINER_H */

