/* @file MissionSys_modMain_container.h
 * Container Interface header for Module MissionSys_modMain
 * Generated automatically from specification; do not modify here
 */

#if !defined(MISSIONSYS_MODMAIN_CONTAINER_H)
#define MISSIONSYS_MODMAIN_CONTAINER_H


/* Include the types from the XML types files */
#include "ECOA.h"

#include "ECOA__DBM.h"

#include "ECOA__SQL.h"

#include "AVS.h"

#include "MissionSys_modMain_user_context.h"

/* Container Types */
#include "MissionSys_modMain_container_types.h"


#if defined(__cplusplus)
extern "C" {
#endif /* __cplusplus */

/* Incomplete definition of the technical (platform-dependent) part of the context
 * (it will be defined privately by the container) */
struct MissionSys_modMain__platform_hook;

/* Module Context structure declaration */
typedef struct 
{
   /*
    * Other container technical data will accessible through the pointer
    * defined here
    */
   struct MissionSys_modMain__platform_hook *platform_hook;

   /* the type MissionSys_modMain_user_context shall be defined by the user
    * in the MissionSys_modMain_user_context.h file to carry the module
    * implementation private data
    */
   MissionSys_modMain_user_context user;

} MissionSys_modMain__context;


/* Logging and fault management services API */
void MissionSys_modMain_container__log_trace
   (MissionSys_modMain__context* context, const ECOA__log log);

void MissionSys_modMain_container__log_debug
   (MissionSys_modMain__context* context, const ECOA__log log);

void MissionSys_modMain_container__log_info
   (MissionSys_modMain__context* context, const ECOA__log log);

void MissionSys_modMain_container__log_warning
   (MissionSys_modMain__context* context, const ECOA__log log);

void MissionSys_modMain_container__raise_error
   (MissionSys_modMain__context* context, const ECOA__log log);

void MissionSys_modMain_container__raise_fatal_error
   (MissionSys_modMain__context* context, const ECOA__log log);

/* Time services API */
void MissionSys_modMain_container__get_relative_local_time
   (MissionSys_modMain__context* context, ECOA__hr_time* relative_local_time);

ECOA__return_status MissionSys_modMain_container__get_UTC_time
   (MissionSys_modMain__context* context, ECOA__global_time* utc_time);

ECOA__return_status MissionSys_modMain_container__get_absolute_system_time
   (MissionSys_modMain__context* context, ECOA__global_time* absolute_system_time);

/* Time resolution services API */
void MissionSys_modMain_container__get_relative_local_time_resolution
   (MissionSys_modMain__context* context, ECOA__duration* relative_local_time_resolution);

void MissionSys_modMain_container__get_UTC_time_resolution
   (MissionSys_modMain__context* context, ECOA__duration* utc_time_resolution);

void MissionSys_modMain_container__get_absolute_system_time_resolution
   (MissionSys_modMain__context* context, ECOA__duration* absolute_system_time_resolution);

void MissionSys_modMain_container__get_CIMSDB_value
   (MissionSys_modMain__context* context,
    ECOA__SQL__StringZ* value);

void MissionSys_modMain_container__get_UserName_value
   (MissionSys_modMain__context* context,
    ECOA__SQL__StringZ* value);

void MissionSys_modMain_container__get_Password_value
   (MissionSys_modMain__context* context,
    ECOA__SQL__StringZ* value);

ECOA__return_status MissionSys_modMain_container__open_remdbm__request_sync
   (MissionSys_modMain__context* context,
    const ECOA__DBM__String* database,
    const ECOA__int32 size,
    const ECOA__DBM__OpenFlags flags,
    const ECOA__DBM__Permissions* mode,
    ECOA__DBM__ConnectionId* connection,
    ECOA__int32* dbmStatus);

ECOA__return_status MissionSys_modMain_container__close_remdbm__request_sync
   (MissionSys_modMain__context* context,
    const ECOA__DBM__ConnectionId connection);

ECOA__return_status MissionSys_modMain_container__store_remdbm__request_sync
   (MissionSys_modMain__context* context,
    const ECOA__DBM__ConnectionId connection,
    const ECOA__DBM__Datum* key,
    const ECOA__DBM__Datum* content,
    const ECOA__DBM__StoreFlag flag,
    ECOA__int32* dbmStatus);

ECOA__return_status MissionSys_modMain_container__fetch_remdbm__request_sync
   (MissionSys_modMain__context* context,
    const ECOA__DBM__ConnectionId connection,
    const ECOA__DBM__Datum* key,
    ECOA__DBM__Datum* content,
    ECOA__int32* dbmStatus);

ECOA__return_status MissionSys_modMain_container__exists_remdbm__request_sync
   (MissionSys_modMain__context* context,
    const ECOA__DBM__ConnectionId connection,
    const ECOA__DBM__Datum* key,
    ECOA__boolean8* exists);

ECOA__return_status MissionSys_modMain_container__delete_remdbm__request_sync
   (MissionSys_modMain__context* context,
    const ECOA__DBM__ConnectionId connection,
    const ECOA__DBM__Datum* key,
    ECOA__int32* dbmStatus);

ECOA__return_status MissionSys_modMain_container__firstkey_remdbm__request_sync
   (MissionSys_modMain__context* context,
    const ECOA__DBM__ConnectionId connection,
    ECOA__DBM__Datum* key,
    ECOA__int32* dbmStatus);

ECOA__return_status MissionSys_modMain_container__nexttkey_remdbm__request_sync
   (MissionSys_modMain__context* context,
    const ECOA__DBM__ConnectionId connection,
    const ECOA__DBM__Datum* key,
    ECOA__DBM__Datum* nextkey,
    ECOA__int32* dbmStatus);

ECOA__return_status MissionSys_modMain_container__reorganize_remdbm__request_sync
   (MissionSys_modMain__context* context,
    const ECOA__DBM__ConnectionId connection,
    ECOA__int32* dbmStatus);

ECOA__return_status MissionSys_modMain_container__sync_remdbm__request_sync
   (MissionSys_modMain__context* context,
    const ECOA__DBM__ConnectionId connection,
    ECOA__int32* dbmStatus);

ECOA__return_status MissionSys_modMain_container__lasterror_remdbm__request_sync
   (MissionSys_modMain__context* context,
    ECOA__int32* errnum,
    ECOA__DBM__String* errtxt);

ECOA__return_status MissionSys_modMain_container__setopt_remdbm__request_sync
   (MissionSys_modMain__context* context,
    const ECOA__DBM__ConnectionId connection,
    const ECOA__DBM__Option option,
    const ECOA__int32 value,
    ECOA__int32* dbmStatus);

ECOA__return_status MissionSys_modMain_container__dump_remdbm__request_sync
   (MissionSys_modMain__context* context,
    const ECOA__DBM__ConnectionId connection,
    const ECOA__DBM__String* fileName,
    ECOA__int32* dbmStatus);

ECOA__return_status MissionSys_modMain_container__take_remdbm__request_sync
   (MissionSys_modMain__context* context,
    const ECOA__DBM__ConnectionId connection,
    const ECOA__DBM__String* fileName,
    ECOA__int32* dbmStatus);

ECOA__return_status MissionSys_modMain_container__getHelp_remdbm__request_sync
   (MissionSys_modMain__context* context,
    const ECOA__DBM__ConnectionId connection,
    ECOA__DBM__String* help,
    ECOA__int32* dbmStatus);

ECOA__return_status MissionSys_modMain_container__getLimits_remdbm__request_sync
   (MissionSys_modMain__context* context,
    const ECOA__DBM__ConnectionId connection,
    ECOA__char8* limits,
    ECOA__int32* dbmStatus);

ECOA__return_status MissionSys_modMain_container__getCounts_remdbm__request_sync
   (MissionSys_modMain__context* context,
    const ECOA__DBM__ConnectionId connection,
    ECOA__char8* counts,
    ECOA__int32* dbmStatus);

ECOA__return_status MissionSys_modMain_container__open_lcldbm__request_sync
   (MissionSys_modMain__context* context,
    const ECOA__DBM__String* database,
    const ECOA__int32 size,
    const ECOA__DBM__OpenFlags flags,
    const ECOA__DBM__Permissions* mode,
    ECOA__DBM__ConnectionId* connection,
    ECOA__int32* dbmStatus);

ECOA__return_status MissionSys_modMain_container__close_lcldbm__request_sync
   (MissionSys_modMain__context* context,
    const ECOA__DBM__ConnectionId connection);

ECOA__return_status MissionSys_modMain_container__store_lcldbm__request_sync
   (MissionSys_modMain__context* context,
    const ECOA__DBM__ConnectionId connection,
    const ECOA__DBM__Datum* key,
    const ECOA__DBM__Datum* content,
    const ECOA__DBM__StoreFlag flag,
    ECOA__int32* dbmStatus);

ECOA__return_status MissionSys_modMain_container__fetch_lcldbm__request_sync
   (MissionSys_modMain__context* context,
    const ECOA__DBM__ConnectionId connection,
    const ECOA__DBM__Datum* key,
    ECOA__DBM__Datum* content,
    ECOA__int32* dbmStatus);

ECOA__return_status MissionSys_modMain_container__exists_lcldbm__request_sync
   (MissionSys_modMain__context* context,
    const ECOA__DBM__ConnectionId connection,
    const ECOA__DBM__Datum* key,
    ECOA__boolean8* exists);

ECOA__return_status MissionSys_modMain_container__delete_lcldbm__request_sync
   (MissionSys_modMain__context* context,
    const ECOA__DBM__ConnectionId connection,
    const ECOA__DBM__Datum* key,
    ECOA__int32* dbmStatus);

ECOA__return_status MissionSys_modMain_container__firstkey_lcldbm__request_sync
   (MissionSys_modMain__context* context,
    const ECOA__DBM__ConnectionId connection,
    ECOA__DBM__Datum* key,
    ECOA__int32* dbmStatus);

ECOA__return_status MissionSys_modMain_container__nexttkey_lcldbm__request_sync
   (MissionSys_modMain__context* context,
    const ECOA__DBM__ConnectionId connection,
    const ECOA__DBM__Datum* key,
    ECOA__DBM__Datum* nextkey,
    ECOA__int32* dbmStatus);

ECOA__return_status MissionSys_modMain_container__reorganize_lcldbm__request_sync
   (MissionSys_modMain__context* context,
    const ECOA__DBM__ConnectionId connection,
    ECOA__int32* dbmStatus);

ECOA__return_status MissionSys_modMain_container__sync_lcldbm__request_sync
   (MissionSys_modMain__context* context,
    const ECOA__DBM__ConnectionId connection,
    ECOA__int32* dbmStatus);

ECOA__return_status MissionSys_modMain_container__lasterror_lcldbm__request_sync
   (MissionSys_modMain__context* context,
    ECOA__int32* errnum,
    ECOA__DBM__String* errtxt);

ECOA__return_status MissionSys_modMain_container__setopt_lcldbm__request_sync
   (MissionSys_modMain__context* context,
    const ECOA__DBM__ConnectionId connection,
    const ECOA__DBM__Option option,
    const ECOA__int32 value,
    ECOA__int32* dbmStatus);

ECOA__return_status MissionSys_modMain_container__dump_lcldbm__request_sync
   (MissionSys_modMain__context* context,
    const ECOA__DBM__ConnectionId connection,
    const ECOA__DBM__String* fileName,
    ECOA__int32* dbmStatus);

ECOA__return_status MissionSys_modMain_container__take_lcldbm__request_sync
   (MissionSys_modMain__context* context,
    const ECOA__DBM__ConnectionId connection,
    const ECOA__DBM__String* fileName,
    ECOA__int32* dbmStatus);

ECOA__return_status MissionSys_modMain_container__getHelp_lcldbm__request_sync
   (MissionSys_modMain__context* context,
    const ECOA__DBM__ConnectionId connection,
    ECOA__DBM__String* help,
    ECOA__int32* dbmStatus);

ECOA__return_status MissionSys_modMain_container__getLimits_lcldbm__request_sync
   (MissionSys_modMain__context* context,
    const ECOA__DBM__ConnectionId connection,
    ECOA__char8* limits,
    ECOA__int32* dbmStatus);

ECOA__return_status MissionSys_modMain_container__getCounts_lcldbm__request_sync
   (MissionSys_modMain__context* context,
    const ECOA__DBM__ConnectionId connection,
    ECOA__char8* counts,
    ECOA__int32* dbmStatus);

ECOA__return_status MissionSys_modMain_container__getConnection__request_async
   (MissionSys_modMain__context* context,
    ECOA__uint32* ID,
    const ECOA__SQL__String* dataSource,
    const ECOA__SQL__NameString* userName,
    const ECOA__SQL__NameString* password);

ECOA__return_status MissionSys_modMain_container__endConnection__request_sync
   (MissionSys_modMain__context* context,
    const ECOA__SQL__ConnectionId connection,
    ECOA__SQL__Error* requestStatus);

ECOA__return_status MissionSys_modMain_container__SQLExecute__request_sync
   (MissionSys_modMain__context* context,
    const ECOA__SQL__ConnectionId connection,
    const ECOA__SQL__String* SQLString,
    ECOA__SQL__ResultSetId* transaction);

ECOA__return_status MissionSys_modMain_container__getResult__request_sync
   (MissionSys_modMain__context* context,
    const ECOA__SQL__ConnectionId connection,
    const ECOA__SQL__ResultSetId transaction,
    const ECOA__SQL__ScrollSet* scroll,
    ECOA__SQL__Error* requestStatus);

ECOA__return_status MissionSys_modMain_container__getResultData__request_sync
   (MissionSys_modMain__context* context,
    const ECOA__SQL__ConnectionId connection,
    const ECOA__SQL__ResultSetId transaction,
    const ECOA__uint16 columnNo,
    ECOA__SQL__ColumnValue* columnValue,
    ECOA__SQL__Error* requestStatus);

ECOA__return_status MissionSys_modMain_container__getResultColumnCount__request_sync
   (MissionSys_modMain__context* context,
    const ECOA__SQL__ConnectionId connection,
    const ECOA__SQL__ResultSetId transaction,
    ECOA__uint16* columnCount,
    ECOA__SQL__Error* requestStatus);

ECOA__return_status MissionSys_modMain_container__getResultColumnInfo__request_sync
   (MissionSys_modMain__context* context,
    const ECOA__SQL__ConnectionId connection,
    const ECOA__SQL__ResultSetId transaction,
    const ECOA__uint16 columnNo,
    ECOA__SQL__ColumnInfo* columnInfo,
    ECOA__SQL__Error* requestStatus);

ECOA__return_status MissionSys_modMain_container__getStatus__request_sync
   (MissionSys_modMain__context* context,
    const ECOA__SQL__ConnectionId connection,
    const ECOA__SQL__ResultSetId transaction,
    const ECOA__int16 recordNo,
    ECOA__SQL__ResultStatus* resultStatus,
    ECOA__SQL__Error* requestStatus);

ECOA__return_status MissionSys_modMain_container__setUpdateTable__request_sync
   (MissionSys_modMain__context* context,
    const ECOA__SQL__ConnectionId connection,
    const ECOA__SQL__NameString* tableName,
    ECOA__SQL__Error* requestStatus);

ECOA__return_status MissionSys_modMain_container__dump__request_sync
   (MissionSys_modMain__context* context,
    const ECOA__SQL__ConnectionId connection,
    const ECOA__SQL__String* fileName,
    const ECOA__SQL__FileType format,
    ECOA__SQL__Error* requestStatus);

ECOA__return_status MissionSys_modMain_container__take__request_sync
   (MissionSys_modMain__context* context,
    const ECOA__SQL__ConnectionId connection,
    const ECOA__SQL__String* fileName,
    const ECOA__SQL__FileType format,
    ECOA__SQL__Error* requestStatus);

ECOA__return_status MissionSys_modMain_container__getHelp__request_sync
   (MissionSys_modMain__context* context,
    const ECOA__SQL__ConnectionId connection,
    ECOA__SQL__String* help,
    ECOA__SQL__Error* requestStatus);

ECOA__return_status MissionSys_modMain_container__listTables__request_sync
   (MissionSys_modMain__context* context,
    const ECOA__SQL__ConnectionId connection,
    ECOA__SQL__TableNameList* tableList,
    ECOA__SQL__Error* requestStatus);

ECOA__return_status MissionSys_modMain_container__getLimits__request_sync
   (MissionSys_modMain__context* context,
    const ECOA__SQL__ConnectionId connection,
    ECOA__SQL__IntegerList* limits,
    ECOA__SQL__Error* requestStatus);

ECOA__return_status MissionSys_modMain_container__getCounts__request_sync
   (MissionSys_modMain__context* context,
    const ECOA__SQL__ConnectionId connection,
    ECOA__SQL__IntegerList* counts,
    ECOA__SQL__Error* requestStatus);

ECOA__return_status MissionSys_modMain_container__getErrorText__request_sync
   (MissionSys_modMain__context* context,
    const ECOA__SQL__Error requestStatus,
    ECOA__SQL__String* statusText);

ECOA__return_status MissionSys_modMain_container__weather__get_read_access
   (MissionSys_modMain__context* context,
    MissionSys_modMain_container__weather_handle* data_handle);


ECOA__return_status MissionSys_modMain_container__weather__release_read_access
   (MissionSys_modMain__context* context,
    MissionSys_modMain_container__weather_handle* data_handle);

void MissionSys_modMain_container__setLocation__send
   (MissionSys_modMain__context* context,
    const Weather__wxLocationString* location);

ECOA__return_status MissionSys_modMain_container__getWeather__request_async
   (MissionSys_modMain__context* context,
    ECOA__uint32* ID,
    const Weather__wxLocationString* location);

ECOA__return_status MissionSys_modMain_container__getForecastWeather__request_async
   (MissionSys_modMain__context* context,
    ECOA__uint32* ID,
    const ECOA__global_time* when,
    const Weather__wxLocationString* location);

ECOA__return_status MissionSys_modMain_container__getWeatherItem__request_sync
   (MissionSys_modMain__context* context,
    const Weather__wxWeatherItem item,
    const Weather__wxLocationString* location,
    Weather__wxItemUnion* value);

ECOA__return_status MissionSys_modMain_container__getForecastWeatherItem__request_sync
   (MissionSys_modMain__context* context,
    const Weather__wxWeatherItem item,
    const ECOA__global_time* when,
    const Weather__wxLocationString* location,
    Weather__wxItemUnion* value);


#if defined(__cplusplus)
}
#endif /* __cplusplus */

#endif  /* MISSIONSYS_MODMAIN_CONTAINER_H */

