/* @file NavSys_modMain_container.h
 * Container Interface header for Module NavSys_modMain
 * Generated automatically from specification; do not modify here
 */

#if !defined(NAVSYS_MODMAIN_CONTAINER_H)
#define NAVSYS_MODMAIN_CONTAINER_H


/* Include the types from the XML types files */
#include "ECOA.h"

#include "ECOA__SQL.h"

#include "ECOA__FileIO.h"

#include "AVS.h"

#include "Weather.h"

#include "NavSys_modMain_user_context.h"

/* Container Types */
#include "NavSys_modMain_container_types.h"


#if defined(__cplusplus)
extern "C" {
#endif /* __cplusplus */

/* Incomplete definition of the technical (platform-dependent) part of the context
 * (it will be defined privately by the container) */
struct NavSys_modMain__platform_hook;

/* Module Context structure declaration */
typedef struct 
{
   /*
    * Other container technical data will accessible through the pointer
    * defined here
    */
   struct NavSys_modMain__platform_hook *platform_hook;

   /* the type NavSys_modMain_user_context shall be defined by the user
    * in the NavSys_modMain_user_context.h file to carry the module
    * implementation private data
    */
   NavSys_modMain_user_context user;

} NavSys_modMain__context;


/* Logging and fault management services API */
void NavSys_modMain_container__log_trace
   (NavSys_modMain__context* context, const ECOA__log log);

void NavSys_modMain_container__log_debug
   (NavSys_modMain__context* context, const ECOA__log log);

void NavSys_modMain_container__log_info
   (NavSys_modMain__context* context, const ECOA__log log);

void NavSys_modMain_container__log_warning
   (NavSys_modMain__context* context, const ECOA__log log);

void NavSys_modMain_container__raise_error
   (NavSys_modMain__context* context, const ECOA__log log);

void NavSys_modMain_container__raise_fatal_error
   (NavSys_modMain__context* context, const ECOA__log log);

/* Time services API */
void NavSys_modMain_container__get_relative_local_time
   (NavSys_modMain__context* context, ECOA__hr_time* relative_local_time);

ECOA__return_status NavSys_modMain_container__get_UTC_time
   (NavSys_modMain__context* context, ECOA__global_time* utc_time);

ECOA__return_status NavSys_modMain_container__get_absolute_system_time
   (NavSys_modMain__context* context, ECOA__global_time* absolute_system_time);

/* Time resolution services API */
void NavSys_modMain_container__get_relative_local_time_resolution
   (NavSys_modMain__context* context, ECOA__duration* relative_local_time_resolution);

void NavSys_modMain_container__get_UTC_time_resolution
   (NavSys_modMain__context* context, ECOA__duration* utc_time_resolution);

void NavSys_modMain_container__get_absolute_system_time_resolution
   (NavSys_modMain__context* context, ECOA__duration* absolute_system_time_resolution);

void NavSys_modMain_container__get_CIMSDB_value
   (NavSys_modMain__context* context,
    ECOA__SQL__StringZ* value);

void NavSys_modMain_container__get_UserName_value
   (NavSys_modMain__context* context,
    ECOA__SQL__StringZ* value);

void NavSys_modMain_container__get_Password_value
   (NavSys_modMain__context* context,
    ECOA__SQL__StringZ* value);

ECOA__return_status NavSys_modMain_container__getConnection__request_async
   (NavSys_modMain__context* context,
    ECOA__uint32* ID,
    const ECOA__SQL__String* dataSource,
    const ECOA__SQL__NameString* userName,
    const ECOA__SQL__NameString* password);

ECOA__return_status NavSys_modMain_container__endConnection__request_sync
   (NavSys_modMain__context* context,
    const ECOA__SQL__ConnectionId connection,
    ECOA__SQL__Error* requestStatus);

ECOA__return_status NavSys_modMain_container__SQLExecute__request_sync
   (NavSys_modMain__context* context,
    const ECOA__SQL__ConnectionId connection,
    const ECOA__SQL__String* SQLString,
    ECOA__SQL__ResultSetId* transaction);

ECOA__return_status NavSys_modMain_container__getResult__request_sync
   (NavSys_modMain__context* context,
    const ECOA__SQL__ConnectionId connection,
    const ECOA__SQL__ResultSetId transaction,
    const ECOA__SQL__ScrollSet* scroll,
    ECOA__SQL__Error* requestStatus);

ECOA__return_status NavSys_modMain_container__getResultData__request_sync
   (NavSys_modMain__context* context,
    const ECOA__SQL__ConnectionId connection,
    const ECOA__SQL__ResultSetId transaction,
    const ECOA__uint16 columnNo,
    ECOA__SQL__ColumnValue* columnValue,
    ECOA__SQL__Error* requestStatus);

ECOA__return_status NavSys_modMain_container__getResultColumnCount__request_sync
   (NavSys_modMain__context* context,
    const ECOA__SQL__ConnectionId connection,
    const ECOA__SQL__ResultSetId transaction,
    ECOA__uint16* columnCount,
    ECOA__SQL__Error* requestStatus);

ECOA__return_status NavSys_modMain_container__getResultColumnInfo__request_sync
   (NavSys_modMain__context* context,
    const ECOA__SQL__ConnectionId connection,
    const ECOA__SQL__ResultSetId transaction,
    const ECOA__uint16 columnNo,
    ECOA__SQL__ColumnInfo* columnInfo,
    ECOA__SQL__Error* requestStatus);

ECOA__return_status NavSys_modMain_container__getStatus__request_sync
   (NavSys_modMain__context* context,
    const ECOA__SQL__ConnectionId connection,
    const ECOA__SQL__ResultSetId transaction,
    const ECOA__int16 recordNo,
    ECOA__SQL__ResultStatus* resultStatus,
    ECOA__SQL__Error* requestStatus);

ECOA__return_status NavSys_modMain_container__setUpdateTable__request_sync
   (NavSys_modMain__context* context,
    const ECOA__SQL__ConnectionId connection,
    const ECOA__SQL__NameString* tableName,
    ECOA__SQL__Error* requestStatus);

ECOA__return_status NavSys_modMain_container__dump__request_sync
   (NavSys_modMain__context* context,
    const ECOA__SQL__ConnectionId connection,
    const ECOA__SQL__String* fileName,
    const ECOA__SQL__FileType format,
    ECOA__SQL__Error* requestStatus);

ECOA__return_status NavSys_modMain_container__take__request_sync
   (NavSys_modMain__context* context,
    const ECOA__SQL__ConnectionId connection,
    const ECOA__SQL__String* fileName,
    const ECOA__SQL__FileType format,
    ECOA__SQL__Error* requestStatus);

ECOA__return_status NavSys_modMain_container__getHelp__request_sync
   (NavSys_modMain__context* context,
    const ECOA__SQL__ConnectionId connection,
    ECOA__SQL__String* help,
    ECOA__SQL__Error* requestStatus);

ECOA__return_status NavSys_modMain_container__listTables__request_sync
   (NavSys_modMain__context* context,
    const ECOA__SQL__ConnectionId connection,
    ECOA__SQL__TableNameList* tableList,
    ECOA__SQL__Error* requestStatus);

ECOA__return_status NavSys_modMain_container__getLimits__request_sync
   (NavSys_modMain__context* context,
    const ECOA__SQL__ConnectionId connection,
    ECOA__SQL__IntegerList* limits,
    ECOA__SQL__Error* requestStatus);

ECOA__return_status NavSys_modMain_container__getCounts__request_sync
   (NavSys_modMain__context* context,
    const ECOA__SQL__ConnectionId connection,
    ECOA__SQL__IntegerList* counts,
    ECOA__SQL__Error* requestStatus);

ECOA__return_status NavSys_modMain_container__getErrorText__request_sync
   (NavSys_modMain__context* context,
    const ECOA__SQL__Error requestStatus,
    ECOA__SQL__String* statusText);

ECOA__return_status NavSys_modMain_container__open__request_sync
   (NavSys_modMain__context* context,
    const ECOA__FileIO__FileName* Name,
    const ECOA__FileIO__ModeFlag Flags,
    const ECOA__FileIO__Permissions* Permissions,
    ECOA__int32* Handle);

ECOA__return_status NavSys_modMain_container__close__request_sync
   (NavSys_modMain__context* context,
    const ECOA__int32 Handle,
    ECOA__int32* Result);

ECOA__return_status NavSys_modMain_container__read__request_sync
   (NavSys_modMain__context* context,
    const ECOA__int32 Handle,
    const ECOA__int32 MaxCount,
    ECOA__FileIO__string* Buffer,
    ECOA__int32* ActualCount);

ECOA__return_status NavSys_modMain_container__write__request_sync
   (NavSys_modMain__context* context,
    const ECOA__int32 Handle,
    const ECOA__FileIO__string* Buffer,
    const ECOA__int32 MaxCount,
    ECOA__int32* ActualCount);

ECOA__return_status NavSys_modMain_container__seek__request_sync
   (NavSys_modMain__context* context,
    const ECOA__int32 Handle,
    const ECOA__int64 Position,
    const ECOA__FileIO__SeekBase Base,
    ECOA__int64* ActualPosn);

ECOA__return_status NavSys_modMain_container__delete__request_sync
   (NavSys_modMain__context* context,
    const ECOA__FileIO__FileName* Name,
    ECOA__int32* Result);

ECOA__return_status NavSys_modMain_container__weather__get_read_access
   (NavSys_modMain__context* context,
    NavSys_modMain_container__weather_handle* data_handle);


ECOA__return_status NavSys_modMain_container__weather__release_read_access
   (NavSys_modMain__context* context,
    NavSys_modMain_container__weather_handle* data_handle);

void NavSys_modMain_container__setLocation__send
   (NavSys_modMain__context* context,
    const Weather__wxLocationString* location);

ECOA__return_status NavSys_modMain_container__getWeather__request_async
   (NavSys_modMain__context* context,
    ECOA__uint32* ID,
    const Weather__wxLocationString* location);

ECOA__return_status NavSys_modMain_container__getForecastWeather__request_async
   (NavSys_modMain__context* context,
    ECOA__uint32* ID,
    const ECOA__global_time* when,
    const Weather__wxLocationString* location);

ECOA__return_status NavSys_modMain_container__getWeatherItem__request_sync
   (NavSys_modMain__context* context,
    const Weather__wxWeatherItem item,
    const Weather__wxLocationString* location,
    Weather__wxItemUnion* value);

ECOA__return_status NavSys_modMain_container__getForecastWeatherItem__request_sync
   (NavSys_modMain__context* context,
    const Weather__wxWeatherItem item,
    const ECOA__global_time* when,
    const Weather__wxLocationString* location,
    Weather__wxItemUnion* value);


#if defined(__cplusplus)
}
#endif /* __cplusplus */

#endif  /* NAVSYS_MODMAIN_CONTAINER_H */

