/* @file dbmServer_modMain_container.h
 * Container Interface header for Module dbmServer_modMain
 * Generated automatically from specification; do not modify here
 */

#if !defined(DBMSERVER_MODMAIN_CONTAINER_H)
#define DBMSERVER_MODMAIN_CONTAINER_H


/* Include the types from the XML types files */
#include "ECOA.h"

#include "ECOA__DBM.h"

#include "dbmServer_modMain_user_context.h"


#if defined(__cplusplus)
extern "C" {
#endif /* __cplusplus */

/* Incomplete definition of the technical (platform-dependent) part of the context
 * (it will be defined privately by the container) */
struct dbmServer_modMain__platform_hook;

/* Module Context structure declaration */
typedef struct 
{
   /*
    * Other container technical data will accessible through the pointer
    * defined here
    */
   struct dbmServer_modMain__platform_hook *platform_hook;

   /* the type dbmServer_modMain_user_context shall be defined by the user
    * in the dbmServer_modMain_user_context.h file to carry the module
    * implementation private data
    */
   dbmServer_modMain_user_context user;

} dbmServer_modMain__context;


/* Logging and fault management services API */
void dbmServer_modMain_container__log_trace
   (dbmServer_modMain__context* context, const ECOA__log log);

void dbmServer_modMain_container__log_debug
   (dbmServer_modMain__context* context, const ECOA__log log);

void dbmServer_modMain_container__log_info
   (dbmServer_modMain__context* context, const ECOA__log log);

void dbmServer_modMain_container__log_warning
   (dbmServer_modMain__context* context, const ECOA__log log);

void dbmServer_modMain_container__raise_error
   (dbmServer_modMain__context* context, const ECOA__log log);

void dbmServer_modMain_container__raise_fatal_error
   (dbmServer_modMain__context* context, const ECOA__log log);

/* Time services API */
void dbmServer_modMain_container__get_relative_local_time
   (dbmServer_modMain__context* context, ECOA__hr_time* relative_local_time);

ECOA__return_status dbmServer_modMain_container__get_UTC_time
   (dbmServer_modMain__context* context, ECOA__global_time* utc_time);

ECOA__return_status dbmServer_modMain_container__get_absolute_system_time
   (dbmServer_modMain__context* context, ECOA__global_time* absolute_system_time);

/* Time resolution services API */
void dbmServer_modMain_container__get_relative_local_time_resolution
   (dbmServer_modMain__context* context, ECOA__duration* relative_local_time_resolution);

void dbmServer_modMain_container__get_UTC_time_resolution
   (dbmServer_modMain__context* context, ECOA__duration* utc_time_resolution);

void dbmServer_modMain_container__get_absolute_system_time_resolution
   (dbmServer_modMain__context* context, ECOA__duration* absolute_system_time_resolution);

ECOA__return_status dbmServer_modMain_container__open__response_send
   (dbmServer_modMain__context* context,
    const ECOA__uint32 ID,
    const ECOA__DBM__ConnectionId connection,
    const ECOA__int32 dbmStatus);

ECOA__return_status dbmServer_modMain_container__close__response_send
   (dbmServer_modMain__context* context,
    const ECOA__uint32 ID);

ECOA__return_status dbmServer_modMain_container__store__response_send
   (dbmServer_modMain__context* context,
    const ECOA__uint32 ID,
    const ECOA__int32 dbmStatus);

ECOA__return_status dbmServer_modMain_container__fetch__response_send
   (dbmServer_modMain__context* context,
    const ECOA__uint32 ID,
    const ECOA__DBM__Datum* content,
    const ECOA__int32 dbmStatus);

ECOA__return_status dbmServer_modMain_container__exists__response_send
   (dbmServer_modMain__context* context,
    const ECOA__uint32 ID,
    const ECOA__boolean8 exists);

ECOA__return_status dbmServer_modMain_container__delete__response_send
   (dbmServer_modMain__context* context,
    const ECOA__uint32 ID,
    const ECOA__int32 dbmStatus);

ECOA__return_status dbmServer_modMain_container__firstkey__response_send
   (dbmServer_modMain__context* context,
    const ECOA__uint32 ID,
    const ECOA__DBM__Datum* key,
    const ECOA__int32 dbmStatus);

ECOA__return_status dbmServer_modMain_container__nexttkey__response_send
   (dbmServer_modMain__context* context,
    const ECOA__uint32 ID,
    const ECOA__DBM__Datum* nextkey,
    const ECOA__int32 dbmStatus);

ECOA__return_status dbmServer_modMain_container__reorganize__response_send
   (dbmServer_modMain__context* context,
    const ECOA__uint32 ID,
    const ECOA__int32 dbmStatus);

ECOA__return_status dbmServer_modMain_container__sync__response_send
   (dbmServer_modMain__context* context,
    const ECOA__uint32 ID,
    const ECOA__int32 dbmStatus);

ECOA__return_status dbmServer_modMain_container__lasterror__response_send
   (dbmServer_modMain__context* context,
    const ECOA__uint32 ID,
    const ECOA__int32 errnum,
    const ECOA__DBM__String* errtxt);

ECOA__return_status dbmServer_modMain_container__setopt__response_send
   (dbmServer_modMain__context* context,
    const ECOA__uint32 ID,
    const ECOA__int32 dbmStatus);

ECOA__return_status dbmServer_modMain_container__dump__response_send
   (dbmServer_modMain__context* context,
    const ECOA__uint32 ID,
    const ECOA__int32 dbmStatus);

ECOA__return_status dbmServer_modMain_container__take__response_send
   (dbmServer_modMain__context* context,
    const ECOA__uint32 ID,
    const ECOA__int32 dbmStatus);

ECOA__return_status dbmServer_modMain_container__getHelp__response_send
   (dbmServer_modMain__context* context,
    const ECOA__uint32 ID,
    const ECOA__DBM__String* help,
    const ECOA__int32 dbmStatus);

ECOA__return_status dbmServer_modMain_container__getLimits__response_send
   (dbmServer_modMain__context* context,
    const ECOA__uint32 ID,
    const ECOA__char8 limits,
    const ECOA__int32 dbmStatus);

ECOA__return_status dbmServer_modMain_container__getCounts__response_send
   (dbmServer_modMain__context* context,
    const ECOA__uint32 ID,
    const ECOA__char8 counts,
    const ECOA__int32 dbmStatus);


#if defined(__cplusplus)
}
#endif /* __cplusplus */

#endif  /* DBMSERVER_MODMAIN_CONTAINER_H */

