/* File dbmServer_modMain_user_context.h */
/*
 ##############################################################
 # (C) 2015 BAE SYSTEMS
 #
 # ECOA Data Servers Sample - Rapid Access Database Server
 #
 # $Id: dbmServer_modMain_user_context.h,v 2.1 2017/11/06 15:33:32 ksappleb Exp $
 #
 # Part of the BAE Systems, Rochester, ECOA Samples collection
 #
 # Created by K S Appleby, BAE Systems, Airport Works, Rochester, Kent
 #
 # This software is developed for and on behalf of BAE Systems (Operations)
 # Limited, Dassault Aviation, Bull SAS, Thales Systemes Aeroportes,
 # GE Aviation Systems Limited,
 # General Dynamics United Kingdom Limited and Leonardo MW Ltd,
 # and the copyright is owned by BAE Systems (Operations) Limited,
 # Dassault Aviation, Bull SAS, Thales Systemes Aeroportes, 
 # GE Aviation Systems Limited, General Dynamics United Kingdom
 # Limited and Leonardo MW Ltd
 #
 # This software is developed by BAE Systems (Operations)
 # Limited, Electronic Systems, and is the Intellectual
 # Property of BAE Systems (Operations) Limited, Electronic Systems.
 #
 # The information set out in this document is provided solely
 # on an 'as is' basis and the co-developers of this software make
 # no warranties expressed or implied, including no warranties
 # as to completeness, accuracy or fitness for purpose, with respect
 # to any of the information.
 ##############################################################
*/
#if !defined(_DBMSERVER_MODMAIN_USER_CONTEXT_H)
#define _DBMSERVER_MODMAIN_USER_CONTEXT_H

#if defined(__cplusplus)
extern "C" {
#endif /* __cplusplus */

/* Container Types */
#include "dbmServer_modMain_container_types.h"

#include <gdbm.h>

/* User Module Context structure example */

#define DBMSERVER_MAXHANDLES 32

typedef struct
{
	GDBM_FILE dbFs[ DBMSERVER_MAXHANDLES ];

} dbmServer_modMain_user_context;

/* Warm Start Module Context structure example */
typedef struct
{
   /* declare the Warm Start Module Context data here */
   int dmy;
} dbmServer_modMain_warm_start_context;

#if defined(__cplusplus)
}
#endif /* __cplusplus */

#endif  /* _DBMSERVER_MODMAIN_USER_CONTEXT_H */
