/* @file fileServer_modMain_container.h
 * Container Interface header for Module fileServer_modMain
 * Generated automatically from specification; do not modify here
 */

#if !defined(FILESERVER_MODMAIN_CONTAINER_H)
#define FILESERVER_MODMAIN_CONTAINER_H


/* Include the types from the XML types files */
#include "ECOA.h"

#include "ECOA__FileIO.h"

#include "fileServer_modMain_user_context.h"


#if defined(__cplusplus)
extern "C" {
#endif /* __cplusplus */

/* Incomplete definition of the technical (platform-dependent) part of the context
 * (it will be defined privately by the container) */
struct fileServer_modMain__platform_hook;

/* Module Context structure declaration */
typedef struct 
{
   /*
    * Other container technical data will accessible through the pointer
    * defined here
    */
   struct fileServer_modMain__platform_hook *platform_hook;

   /* the type fileServer_modMain_user_context shall be defined by the user
    * in the fileServer_modMain_user_context.h file to carry the module
    * implementation private data
    */
   fileServer_modMain_user_context user;

} fileServer_modMain__context;


/* Logging and fault management services API */
void fileServer_modMain_container__log_trace
   (fileServer_modMain__context* context, const ECOA__log log);

void fileServer_modMain_container__log_debug
   (fileServer_modMain__context* context, const ECOA__log log);

void fileServer_modMain_container__log_info
   (fileServer_modMain__context* context, const ECOA__log log);

void fileServer_modMain_container__log_warning
   (fileServer_modMain__context* context, const ECOA__log log);

void fileServer_modMain_container__raise_error
   (fileServer_modMain__context* context, const ECOA__log log);

void fileServer_modMain_container__raise_fatal_error
   (fileServer_modMain__context* context, const ECOA__log log);

/* Time services API */
void fileServer_modMain_container__get_relative_local_time
   (fileServer_modMain__context* context, ECOA__hr_time* relative_local_time);

ECOA__return_status fileServer_modMain_container__get_UTC_time
   (fileServer_modMain__context* context, ECOA__global_time* utc_time);

ECOA__return_status fileServer_modMain_container__get_absolute_system_time
   (fileServer_modMain__context* context, ECOA__global_time* absolute_system_time);

/* Time resolution services API */
void fileServer_modMain_container__get_relative_local_time_resolution
   (fileServer_modMain__context* context, ECOA__duration* relative_local_time_resolution);

void fileServer_modMain_container__get_UTC_time_resolution
   (fileServer_modMain__context* context, ECOA__duration* utc_time_resolution);

void fileServer_modMain_container__get_absolute_system_time_resolution
   (fileServer_modMain__context* context, ECOA__duration* absolute_system_time_resolution);

ECOA__return_status fileServer_modMain_container__open__response_send
   (fileServer_modMain__context* context,
    const ECOA__uint32 ID,
    const ECOA__int32 handle);

ECOA__return_status fileServer_modMain_container__close__response_send
   (fileServer_modMain__context* context,
    const ECOA__uint32 ID,
    const ECOA__int32 result);

ECOA__return_status fileServer_modMain_container__read__response_send
   (fileServer_modMain__context* context,
    const ECOA__uint32 ID,
    const ECOA__FileIO__string* buffer,
    const ECOA__int32 actualCount);

ECOA__return_status fileServer_modMain_container__write__response_send
   (fileServer_modMain__context* context,
    const ECOA__uint32 ID,
    const ECOA__int32 actualCount);

ECOA__return_status fileServer_modMain_container__seek__response_send
   (fileServer_modMain__context* context,
    const ECOA__uint32 ID,
    const ECOA__int64 actualPosn);

ECOA__return_status fileServer_modMain_container__delete__response_send
   (fileServer_modMain__context* context,
    const ECOA__uint32 ID,
    const ECOA__int32 result);

ECOA__return_status fileServer_modMain_container__opendir__response_send
   (fileServer_modMain__context* context,
    const ECOA__uint32 ID,
    const ECOA__int32 handle);

ECOA__return_status fileServer_modMain_container__readdir__response_send
   (fileServer_modMain__context* context,
    const ECOA__uint32 ID,
    const ECOA__FileIO__DirEntry* entry,
    const ECOA__int32 result);

ECOA__return_status fileServer_modMain_container__closedir__response_send
   (fileServer_modMain__context* context,
    const ECOA__uint32 ID,
    const ECOA__int32 result);


#if defined(__cplusplus)
}
#endif /* __cplusplus */

#endif  /* FILESERVER_MODMAIN_CONTAINER_H */

