/* @file metServer_modMain_container.h
 * Container Interface header for Module metServer_modMain
 * Generated automatically from specification; do not modify here
 */

#if !defined(METSERVER_MODMAIN_CONTAINER_H)
#define METSERVER_MODMAIN_CONTAINER_H


/* Include the types from the XML types files */
#include "ECOA.h"

#include "Weather.h"

#include "metServer_modMain_user_context.h"

/* Container Types */
#include "metServer_modMain_container_types.h"


#if defined(__cplusplus)
extern "C" {
#endif /* __cplusplus */

/* Incomplete definition of the technical (platform-dependent) part of the context
 * (it will be defined privately by the container) */
struct metServer_modMain__platform_hook;

/* Module Context structure declaration */
typedef struct 
{
   /*
    * Other container technical data will accessible through the pointer
    * defined here
    */
   struct metServer_modMain__platform_hook *platform_hook;

   /* the type metServer_modMain_user_context shall be defined by the user
    * in the metServer_modMain_user_context.h file to carry the module
    * implementation private data
    */
   metServer_modMain_user_context user;

} metServer_modMain__context;


/* Logging and fault management services API */
void metServer_modMain_container__log_trace
   (metServer_modMain__context* context, const ECOA__log log);

void metServer_modMain_container__log_debug
   (metServer_modMain__context* context, const ECOA__log log);

void metServer_modMain_container__log_info
   (metServer_modMain__context* context, const ECOA__log log);

void metServer_modMain_container__log_warning
   (metServer_modMain__context* context, const ECOA__log log);

void metServer_modMain_container__raise_error
   (metServer_modMain__context* context, const ECOA__log log);

void metServer_modMain_container__raise_fatal_error
   (metServer_modMain__context* context, const ECOA__log log);

/* Time services API */
void metServer_modMain_container__get_relative_local_time
   (metServer_modMain__context* context, ECOA__hr_time* relative_local_time);

ECOA__return_status metServer_modMain_container__get_UTC_time
   (metServer_modMain__context* context, ECOA__global_time* utc_time);

ECOA__return_status metServer_modMain_container__get_absolute_system_time
   (metServer_modMain__context* context, ECOA__global_time* absolute_system_time);

/* Time resolution services API */
void metServer_modMain_container__get_relative_local_time_resolution
   (metServer_modMain__context* context, ECOA__duration* relative_local_time_resolution);

void metServer_modMain_container__get_UTC_time_resolution
   (metServer_modMain__context* context, ECOA__duration* utc_time_resolution);

void metServer_modMain_container__get_absolute_system_time_resolution
   (metServer_modMain__context* context, ECOA__duration* absolute_system_time_resolution);

ECOA__return_status metServer_modMain_container__weather__get_write_access
   (metServer_modMain__context* context,
    metServer_modMain_container__weather_handle* data_handle);

ECOA__return_status metServer_modMain_container__weather__cancel_write_access
   (metServer_modMain__context* context,
    metServer_modMain_container__weather_handle* data_handle);

ECOA__return_status metServer_modMain_container__weather__publish_write_access
   (metServer_modMain__context* context,
    metServer_modMain_container__weather_handle* data_handle);

ECOA__return_status metServer_modMain_container__getWeather__response_send
   (metServer_modMain__context* context,
    const ECOA__uint32 ID,
    const Weather__WeatherRecd* weather);

ECOA__return_status metServer_modMain_container__getForecastWeather__response_send
   (metServer_modMain__context* context,
    const ECOA__uint32 ID,
    const Weather__WeatherRecd* weather);

ECOA__return_status metServer_modMain_container__getWeatherItem__response_send
   (metServer_modMain__context* context,
    const ECOA__uint32 ID,
    const Weather__wxItemUnion* value);

ECOA__return_status metServer_modMain_container__getForecastWeatherItem__response_send
   (metServer_modMain__context* context,
    const ECOA__uint32 ID,
    const Weather__wxItemUnion* value);


#if defined(__cplusplus)
}
#endif /* __cplusplus */

#endif  /* METSERVER_MODMAIN_CONTAINER_H */

