/* @file sqlServer_modMain_container.h
 * Container Interface header for Module sqlServer_modMain
 * Generated automatically from specification; do not modify here
 */

#if !defined(SQLSERVER_MODMAIN_CONTAINER_H)
#define SQLSERVER_MODMAIN_CONTAINER_H


/* Include the types from the XML types files */
#include "ECOA.h"

#include "ECOA__SQL.h"


#if defined(__cplusplus)
extern "C" {
#endif /* __cplusplus */

/* Incomplete definition of the technical (platform-dependent) part of the context
 * (it will be defined privately by the container) */
struct sqlServer_modMain__platform_hook;

/* Module Context structure declaration */
typedef struct 
{
   /*
    * Other container technical data will accessible through the pointer
    * defined here
    */
   struct sqlServer_modMain__platform_hook *platform_hook;

} sqlServer_modMain__context;


/* Logging and fault management services API */
void sqlServer_modMain_container__log_trace
   (sqlServer_modMain__context* context, const ECOA__log log);

void sqlServer_modMain_container__log_debug
   (sqlServer_modMain__context* context, const ECOA__log log);

void sqlServer_modMain_container__log_info
   (sqlServer_modMain__context* context, const ECOA__log log);

void sqlServer_modMain_container__log_warning
   (sqlServer_modMain__context* context, const ECOA__log log);

void sqlServer_modMain_container__raise_error
   (sqlServer_modMain__context* context, const ECOA__log log);

void sqlServer_modMain_container__raise_fatal_error
   (sqlServer_modMain__context* context, const ECOA__log log);

/* Time services API */
void sqlServer_modMain_container__get_relative_local_time
   (sqlServer_modMain__context* context, ECOA__hr_time* relative_local_time);

ECOA__return_status sqlServer_modMain_container__get_UTC_time
   (sqlServer_modMain__context* context, ECOA__global_time* utc_time);

ECOA__return_status sqlServer_modMain_container__get_absolute_system_time
   (sqlServer_modMain__context* context, ECOA__global_time* absolute_system_time);

/* Time resolution services API */
void sqlServer_modMain_container__get_relative_local_time_resolution
   (sqlServer_modMain__context* context, ECOA__duration* relative_local_time_resolution);

void sqlServer_modMain_container__get_UTC_time_resolution
   (sqlServer_modMain__context* context, ECOA__duration* utc_time_resolution);

void sqlServer_modMain_container__get_absolute_system_time_resolution
   (sqlServer_modMain__context* context, ECOA__duration* absolute_system_time_resolution);

ECOA__return_status sqlServer_modMain_container__getConnection__response_send
   (sqlServer_modMain__context* context,
    const ECOA__uint32 ID,
    const ECOA__SQL__ConnectionId connection,
    const ECOA__SQL__Error requestStatus);

ECOA__return_status sqlServer_modMain_container__endConnection__response_send
   (sqlServer_modMain__context* context,
    const ECOA__uint32 ID,
    const ECOA__SQL__Error requestStatus);

ECOA__return_status sqlServer_modMain_container__SQLExecute__response_send
   (sqlServer_modMain__context* context,
    const ECOA__uint32 ID,
    const ECOA__SQL__ResultSetId transaction);

ECOA__return_status sqlServer_modMain_container__getResult__response_send
   (sqlServer_modMain__context* context,
    const ECOA__uint32 ID,
    const ECOA__SQL__Error requestStatus);

ECOA__return_status sqlServer_modMain_container__getResultData__response_send
   (sqlServer_modMain__context* context,
    const ECOA__uint32 ID,
    const ECOA__SQL__ColumnValue* columnValue,
    const ECOA__SQL__Error requestStatus);

ECOA__return_status sqlServer_modMain_container__getResultColumnCount__response_send
   (sqlServer_modMain__context* context,
    const ECOA__uint32 ID,
    const ECOA__uint16 columnCount,
    const ECOA__SQL__Error requestStatus);

ECOA__return_status sqlServer_modMain_container__getResultColumnInfo__response_send
   (sqlServer_modMain__context* context,
    const ECOA__uint32 ID,
    const ECOA__SQL__ColumnInfo* columnInfo,
    const ECOA__SQL__Error requestStatus);

ECOA__return_status sqlServer_modMain_container__getStatus__response_send
   (sqlServer_modMain__context* context,
    const ECOA__uint32 ID,
    const ECOA__SQL__ResultStatus* resultStatus,
    const ECOA__SQL__Error requestStatus);

ECOA__return_status sqlServer_modMain_container__setUpdateTable__response_send
   (sqlServer_modMain__context* context,
    const ECOA__uint32 ID,
    const ECOA__SQL__Error requestStatus);

ECOA__return_status sqlServer_modMain_container__dump__response_send
   (sqlServer_modMain__context* context,
    const ECOA__uint32 ID,
    const ECOA__SQL__Error requestStatus);

ECOA__return_status sqlServer_modMain_container__take__response_send
   (sqlServer_modMain__context* context,
    const ECOA__uint32 ID,
    const ECOA__SQL__Error requestStatus);

ECOA__return_status sqlServer_modMain_container__getHelp__response_send
   (sqlServer_modMain__context* context,
    const ECOA__uint32 ID,
    const ECOA__SQL__String* help,
    const ECOA__SQL__Error requestStatus);

ECOA__return_status sqlServer_modMain_container__listTables__response_send
   (sqlServer_modMain__context* context,
    const ECOA__uint32 ID,
    const ECOA__SQL__TableNameList* tableList,
    const ECOA__SQL__Error requestStatus);

ECOA__return_status sqlServer_modMain_container__getLimits__response_send
   (sqlServer_modMain__context* context,
    const ECOA__uint32 ID,
    const ECOA__SQL__IntegerList* limits,
    const ECOA__SQL__Error requestStatus);

ECOA__return_status sqlServer_modMain_container__getCounts__response_send
   (sqlServer_modMain__context* context,
    const ECOA__uint32 ID,
    const ECOA__SQL__IntegerList* counts,
    const ECOA__SQL__Error requestStatus);

void sqlServer_modMain_container__tableUpdateNotification__send
   (sqlServer_modMain__context* context,
    const ECOA__SQL__NameString* tableName);

ECOA__return_status sqlServer_modMain_container__getErrorText__response_send
   (sqlServer_modMain__context* context,
    const ECOA__uint32 ID,
    const ECOA__SQL__String* statusText);


#if defined(__cplusplus)
}
#endif /* __cplusplus */

#endif  /* SQLSERVER_MODMAIN_CONTAINER_H */

