/* File AVS.hpp */

#if !defined(AVS_HPP)
#define AVS_HPP

#include "ECOA.hpp" /* Fundamental types declared for the platform */

namespace AVS {


/* Array type */
const ECOA::uint32 AVS_MAXSIZE  = 8192;
typedef struct
{
   ECOA::uint32 current_size;
   ECOA::byte data[AVS_MAXSIZE];
} AVS;

/* Record type */
typedef struct
{
   ECOA::double64 Latitude;
   ECOA::double64 Longitude;
   ECOA::double64 Height;
   ECOA::double64 Speed;
   ECOA::double64 Heading;
} AVSType;


} /* AVS */

#endif  /* AVS_HPP */
