-- File ECOA-URL.ads

-- Standard ECOA Types
with ECOA;


package ECOA.URL is

-- Fixed Array type
type Protocol_Index is range 0..32-1;
type Protocol is array
    (Protocol_Index) of ECOA.Character_8_Type;

-- Fixed Array type
type HostName_Index is range 0..256-1;
type HostName is array
    (HostName_Index) of ECOA.Character_8_Type;

-- Fixed Array type
type FileName_Index is range 0..256-1;
type FileName is array
    (FileName_Index) of ECOA.Character_8_Type;

-- Record type
type URL is
   record
      protocol : Protocol;
      host : HostName;
      port : ECOA.Signed_32_Type;
      file : FileName;
   end record;


end ECOA.URL;
