/* File ECOA__DBM.h */
#if !defined(ECOA__DBM_H)
#define ECOA__DBM_H

#include "ECOA.h" /* Fundamental types declared for the platform */

#if defined(__cplusplus)
extern "C" {
#endif /* __cplusplus */

/* Simple type, min is 0, max is 4294967295 */
typedef ECOA__uint32 ECOA__DBM__ConnectionId;
#define ECOA__DBM__ConnectionId_minRange (0)
#define ECOA__DBM__ConnectionId_maxRange (4294967295)

/* Enum type */
typedef ECOA__int16 ECOA__DBM__Option;
#define ECOA__DBM__Option_SETCACHESIZE (1)
#define ECOA__DBM__Option_SETFASTMODE (2)
#define ECOA__DBM__Option_SETSYNCMODE (3)
#define ECOA__DBM__Option_SETCENTFREE (4)
#define ECOA__DBM__Option_SETCOALESCEBLKS (5)
#define ECOA__DBM__Option_SETMAXMAPSIZE (6)
#define ECOA__DBM__Option_SETMMAP (7)
#define ECOA__DBM__Option_GETFLAGS (8)
#define ECOA__DBM__Option_GETMMAP (9)
#define ECOA__DBM__Option_GETCACHESIZE (10)
#define ECOA__DBM__Option_GETSYNMODE (11)
#define ECOA__DBM__Option_GETCENTFREE (12)
#define ECOA__DBM__Option_GETCOALESCEBLKS (13)
#define ECOA__DBM__Option_GETMAXMAPSIZE (14)
#define ECOA__DBM__Option_GETDBNAME (15)

/* Enum type */
typedef ECOA__int16 ECOA__DBM__OpenFlag;
#define ECOA__DBM__OpenFlag_READER (0)
#define ECOA__DBM__OpenFlag_WRITER (1)
#define ECOA__DBM__OpenFlag_WRCREAT (2)
#define ECOA__DBM__OpenFlag_NEWDB (3)
#define ECOA__DBM__OpenFlag_FAST (16)
#define ECOA__DBM__OpenFlag_SYNC (32)
#define ECOA__DBM__OpenFlag_NOLOCK (64)
#define ECOA__DBM__OpenFlag_NOMMAP (128)
#define ECOA__DBM__OpenFlag_CLOEXEC (256)

/* Simple type, min is -2147483647, max is 2147483647 */
typedef ECOA__int32 ECOA__DBM__OpenFlags;
#define ECOA__DBM__OpenFlags_minRange (-2147483647)
#define ECOA__DBM__OpenFlags_maxRange (2147483647)

/* Enum type */
typedef ECOA__int16 ECOA__DBM__StoreFlag;
#define ECOA__DBM__StoreFlag_INSERT (0)
#define ECOA__DBM__StoreFlag_REPLACE (1)

/* Enum type */
typedef ECOA__uint8 ECOA__DBM__Permission;
#define ECOA__DBM__Permission_READ (4)
#define ECOA__DBM__Permission_WRITE (2)
#define ECOA__DBM__Permission_EXECUTE (1)
#define ECOA__DBM__Permission_READEXEC (5)
#define ECOA__DBM__Permission_ALL (7)

/* Record type */
typedef struct
{
   ECOA__DBM__Permission Owner;
   ECOA__DBM__Permission Group;
   ECOA__DBM__Permission Others;
} ECOA__DBM__Permissions;

/* Array type */
#define ECOA__DBM__String_MAXSIZE 65536
typedef struct
{
   ECOA__uint32 current_size;
   ECOA__char8 data[ECOA__DBM__String_MAXSIZE];
} ECOA__DBM__String;

/* Array type */
#define ECOA__DBM__NameString_MAXSIZE 128
typedef struct
{
   ECOA__uint32 current_size;
   ECOA__char8 data[ECOA__DBM__NameString_MAXSIZE];
} ECOA__DBM__NameString;

/* Array type */
#define ECOA__DBM__Datum_MAXSIZE 65536
typedef struct
{
   ECOA__uint32 current_size;
   ECOA__char8 data[ECOA__DBM__Datum_MAXSIZE];
} ECOA__DBM__Datum;


#if defined(__cplusplus)
}
#endif /* __cplusplus */

#endif  /* ECOA__DBM_H */
