/* File ECOA__URL.hpp */

#if !defined(ECOA__URL_HPP)
#define ECOA__URL_HPP

#include "ECOA.hpp" /* Fundamental types declared for the platform */

namespace ECOA {

namespace URL {


/* Fixed array type */
const ECOA::uint32 Protocol_MAXSIZE  = 32;
typedef ECOA::char8 Protocol[Protocol_MAXSIZE];

/* Fixed array type */
const ECOA::uint32 HostName_MAXSIZE  = 256;
typedef ECOA::char8 HostName[HostName_MAXSIZE];

/* Fixed array type */
const ECOA::uint32 FileName_MAXSIZE  = 256;
typedef ECOA::char8 FileName[FileName_MAXSIZE];

/* Record type */
typedef struct
{
   Protocol protocol;
   HostName host;
   ECOA::int32 port;
   FileName file;
} URL;


} /* URL */

} /* ECOA */

#endif  /* ECOA__URL_HPP */
