-- File AVS.ads

-- Standard ECOA Types
with ECOA;


package AVS is

-- Array type
type AVS_Size is range 0..8192;
for AVS_Size'Size use ECOA.Unsigned_32_Type'Size;
subtype AVS_Index is AVS_Size range 0..8192-1;
type AVS_Data is array
    (AVS_Index) of ECOA.Byte_Type;
type AVS is
   record
      Current_Size : AVS_Size;
      Data         : AVS_Data;
   end record;

-- Record type
type AVSType is
   record
      Latitude : ECOA.Float_64_Type;
      Longitude : ECOA.Float_64_Type;
      Height : ECOA.Float_64_Type;
      Speed : ECOA.Float_64_Type;
      Heading : ECOA.Float_64_Type;
   end record;


end AVS;
