-- File Weather.ads

-- Standard ECOA Types
with ECOA;


package Weather is

-- Fixed Array type
type wxLocationString_Index is range 0..128-1;
type wxLocationString is array
    (wxLocationString_Index) of ECOA.Character_8_Type;

-- Fixed Array type
type wxSynopsis_Index is range 0..128-1;
type wxSynopsis is array
    (wxSynopsis_Index) of ECOA.Character_8_Type;

-- Fixed Array type
type wxWindDir_Index is range 0..4-1;
type wxWindDir is array
    (wxWindDir_Index) of ECOA.Character_8_Type;

-- Enum type
type wxWeatherItem is 
   (wxWeatherItem_TEMP,
wxWeatherItem_MINTEMP,
wxWeatherItem_MAXTEMP,
wxWeatherItem_WINDIR,
wxWeatherItem_WINSPD,
wxWeatherItem_PRESS,
wxWeatherItem_CLOUD,
wxWeatherItem_PRECIP,
wxWeatherItem_SYNOP);
for wxWeatherItem use
   (wxWeatherItem_TEMP => 0,
wxWeatherItem_MINTEMP => 1,
wxWeatherItem_MAXTEMP => 2,
wxWeatherItem_WINDIR => 3,
wxWeatherItem_WINSPD => 4,
wxWeatherItem_PRESS => 5,
wxWeatherItem_CLOUD => 6,
wxWeatherItem_PRECIP => 7,
wxWeatherItem_SYNOP => 8);
for wxWeatherItem'Size use ECOA.Signed_8_Type'Size;
for wxWeatherItem'Alignment use ECOA.Signed_8_Type'Alignment;

-- Record type
type WeatherRecd is
   record
      Timestamp : ECOA.Global_Time_Type;
      Location : wxLocationString;
      TemperatureC : ECOA.Float_32_Type;
      MinTempC : ECOA.Float_32_Type;
      MaxtempC : ECOA.Float_32_Type;
      WindDir : wxWindDir;
      WindSpeedMPH : ECOA.Float_32_Type;
      PressureMB : ECOA.Float_32_Type;
      CloudCoverPCNT : ECOA.Float_32_Type;
      PreciptationMM : ECOA.Float_32_Type;
      Synopsis : wxSynopsis;
   end record;


end Weather;
