-- File Weather.ads

-- Standard ECOA Types
with ECOA;


package Weather is

-- Fixed Array type
type wxLocationString_Index is range 0..128-1;
type wxLocationString is array
    (wxLocationString_Index) of ECOA.Character_8_Type;

-- Fixed Array type
type wxSynopsis_Index is range 0..128-1;
type wxSynopsis is array
    (wxSynopsis_Index) of ECOA.Character_8_Type;

-- Fixed Array type
type wxWindDir_Index is range 0..4-1;
type wxWindDir is array
    (wxWindDir_Index) of ECOA.Character_8_Type;

-- Enum type
type wxWeatherItem is new ECOA.Signed_8_Type;
wxWeatherItem_TEMP : constant wxWeatherItem := 0;
wxWeatherItem_MINTEMP : constant wxWeatherItem := 1;
wxWeatherItem_MAXTEMP : constant wxWeatherItem := 2;
wxWeatherItem_WINDIR : constant wxWeatherItem := 3;
wxWeatherItem_WINSPD : constant wxWeatherItem := 4;
wxWeatherItem_PRESS : constant wxWeatherItem := 5;
wxWeatherItem_CLOUD : constant wxWeatherItem := 6;
wxWeatherItem_PRECIP : constant wxWeatherItem := 7;
wxWeatherItem_SYNOP : constant wxWeatherItem := 8;

-- VariantRecord type
type wxItemUnion (param : wxWeatherItem) is
   record
      case param is
         when wxWeatherItem_PRECIP =>
            PreciptationMM : ECOA.Float_32_Type;
         when wxWeatherItem_MAXTEMP =>
            MaxtempC : ECOA.Float_32_Type;
         when wxWeatherItem_SYNOP =>
            Synopsis : wxSynopsis;
         when wxWeatherItem_TEMP =>
            TemperatureC : ECOA.Float_32_Type;
         when wxWeatherItem_WINSPD =>
            WindSpeedMPH : ECOA.Float_32_Type;
         when wxWeatherItem_MINTEMP =>
            MinTempC : ECOA.Float_32_Type;
         when wxWeatherItem_CLOUD =>
            CloudCoverPCNT : ECOA.Float_32_Type;
         when wxWeatherItem_PRESS =>
            PressureMB : ECOA.Float_32_Type;
         when wxWeatherItem_WINDIR =>
            WindDir : wxWindDir;
         when others =>
            null;
      end case;
   end record;

-- Record type
type WeatherRecd is
   record
      Timestamp : ECOA.Global_Time_Type;
      Location : wxLocationString;
      TemperatureC : ECOA.Float_32_Type;
      MinTempC : ECOA.Float_32_Type;
      MaxtempC : ECOA.Float_32_Type;
      WindDir : wxWindDir;
      WindSpeedMPH : ECOA.Float_32_Type;
      PressureMB : ECOA.Float_32_Type;
      CloudCoverPCNT : ECOA.Float_32_Type;
      PreciptationMM : ECOA.Float_32_Type;
      Synopsis : wxSynopsis;
   end record;


end Weather;
