/* File Weather.h */
#if !defined(WEATHER_H)
#define WEATHER_H

#include "ECOA.h" /* Fundamental types declared for the platform */

#if defined(__cplusplus)
extern "C" {
#endif /* __cplusplus */

/* Fixed array type */
#define Weather__wxLocationString_MAXSIZE 128
typedef ECOA__char8 Weather__wxLocationString[Weather__wxLocationString_MAXSIZE];

/* Fixed array type */
#define Weather__wxSynopsis_MAXSIZE 128
typedef ECOA__char8 Weather__wxSynopsis[Weather__wxSynopsis_MAXSIZE];

/* Fixed array type */
#define Weather__wxWindDir_MAXSIZE 4
typedef ECOA__char8 Weather__wxWindDir[Weather__wxWindDir_MAXSIZE];

/* Enum type */
typedef ECOA__int8 Weather__wxWeatherItem;
#define Weather__wxWeatherItem_TEMP (0)
#define Weather__wxWeatherItem_MINTEMP (1)
#define Weather__wxWeatherItem_MAXTEMP (2)
#define Weather__wxWeatherItem_WINDIR (3)
#define Weather__wxWeatherItem_WINSPD (4)
#define Weather__wxWeatherItem_PRESS (5)
#define Weather__wxWeatherItem_CLOUD (6)
#define Weather__wxWeatherItem_PRECIP (7)
#define Weather__wxWeatherItem_SYNOP (8)

/* VariantRecord type */
typedef struct
{
   Weather__wxWeatherItem param; /* Discriminant */
   union
   {
      ECOA__float32 PreciptationMM; /* Applies when discriminant is PRECIP */
      ECOA__float32 MaxtempC; /* Applies when discriminant is MAXTEMP */
      Weather__wxSynopsis Synopsis; /* Applies when discriminant is SYNOP */
      ECOA__float32 TemperatureC; /* Applies when discriminant is TEMP */
      ECOA__float32 WindSpeedMPH; /* Applies when discriminant is WINSPD */
      ECOA__float32 MinTempC; /* Applies when discriminant is MINTEMP */
      ECOA__float32 CloudCoverPCNT; /* Applies when discriminant is CLOUD */
      ECOA__float32 PressureMB; /* Applies when discriminant is PRESS */
      Weather__wxWindDir WindDir; /* Applies when discriminant is WINDIR */
   } u_param;
} Weather__wxItemUnion;

/* Record type */
typedef struct
{
   ECOA__global_time Timestamp;
   Weather__wxLocationString Location;
   ECOA__float32 TemperatureC;
   ECOA__float32 MinTempC;
   ECOA__float32 MaxtempC;
   Weather__wxWindDir WindDir;
   ECOA__float32 WindSpeedMPH;
   ECOA__float32 PressureMB;
   ECOA__float32 CloudCoverPCNT;
   ECOA__float32 PreciptationMM;
   Weather__wxSynopsis Synopsis;
} Weather__WeatherRecd;


#if defined(__cplusplus)
}
#endif /* __cplusplus */

#endif  /* WEATHER_H */
