/* File Weather.hpp */

#if !defined(WEATHER_HPP)
#define WEATHER_HPP

#include "ECOA.hpp" /* Fundamental types declared for the platform */

namespace Weather {


/* Fixed array type */
const ECOA::uint32 wxLocationString_MAXSIZE  = 128;
typedef ECOA::char8 wxLocationString[wxLocationString_MAXSIZE];

/* Fixed array type */
const ECOA::uint32 wxSynopsis_MAXSIZE  = 128;
typedef ECOA::char8 wxSynopsis[wxSynopsis_MAXSIZE];

/* Fixed array type */
const ECOA::uint32 wxWindDir_MAXSIZE  = 4;
typedef ECOA::char8 wxWindDir[wxWindDir_MAXSIZE];

/* Enum type */
struct wxWeatherItem
{
   ECOA::int8 value;
   enum EnumValues {
      TEMP = 0,
      MINTEMP = 1,
      MAXTEMP = 2,
      WINDIR = 3,
      WINSPD = 4,
      PRESS = 5,
      CLOUD = 6,
      PRECIP = 7,
      SYNOP = 8
   };
inline void operator = (ECOA::int8 i) { value = i; }
inline operator ECOA::int8() const { return value; }
};

/* VariantRecord type */
typedef struct
{
   wxWeatherItem param; /* Discriminant */

   union
   {
      ECOA::float32 PreciptationMM; /* Applies when discriminant is PRECIP */
      ECOA::float32 MaxtempC; /* Applies when discriminant is MAXTEMP */
      wxSynopsis Synopsis; /* Applies when discriminant is SYNOP */
      ECOA::float32 TemperatureC; /* Applies when discriminant is TEMP */
      ECOA::float32 WindSpeedMPH; /* Applies when discriminant is WINSPD */
      ECOA::float32 MinTempC; /* Applies when discriminant is MINTEMP */
      ECOA::float32 CloudCoverPCNT; /* Applies when discriminant is CLOUD */
      ECOA::float32 PressureMB; /* Applies when discriminant is PRESS */
      wxWindDir WindDir; /* Applies when discriminant is WINDIR */
   } u_param;
} wxItemUnion;

/* Record type */
typedef struct
{
   ECOA::global_time Timestamp;
   wxLocationString Location;
   ECOA::float32 TemperatureC;
   ECOA::float32 MinTempC;
   ECOA::float32 MaxtempC;
   wxWindDir WindDir;
   ECOA::float32 WindSpeedMPH;
   ECOA::float32 PressureMB;
   ECOA::float32 CloudCoverPCNT;
   ECOA::float32 PreciptationMM;
   wxSynopsis Synopsis;
} WeatherRecd;


} /* Weather */

#endif  /* WEATHER_HPP */
