/* File demo1B.h */
#if !defined(DEMO1B_H)
#define DEMO1B_H

#include "ECOA.h" /* Fundamental types declared for the platform */

#if defined(__cplusplus)
extern "C" {
#endif /* __cplusplus */

/* Enum type */
typedef ECOA__uint8 demo1B__T_Align_State;
#define demo1B__T_Align_State_NOT_ALIGNED (0)
#define demo1B__T_Align_State_ALIGNED (1)

/* Enum type */
typedef ECOA__uint8 demo1B__T_Readiness_State;
#define demo1B__T_Readiness_State_NOT_READY (0)
#define demo1B__T_Readiness_State_READY (1)

/* Enum type */
typedef ECOA__uint8 demo1B__T_Commanded_Power_State;
#define demo1B__T_Commanded_Power_State_OFF (0)
#define demo1B__T_Commanded_Power_State_ON (1)

/* Enum type */
typedef ECOA__uint8 demo1B__T_Availability;
#define demo1B__T_Availability_UNAVAILABLE (0)
#define demo1B__T_Availability_AVAILABLE (1)

/* Enum type */
typedef ECOA__uint8 demo1B__T_Sensor_Mode;
#define demo1B__T_Sensor_Mode_PURSUIT (0)
#define demo1B__T_Sensor_Mode_MAP (1)

/* Enum type */
typedef ECOA__uint8 demo1B__T_EO_IR_Mode;
#define demo1B__T_EO_IR_Mode_NONE (0)
#define demo1B__T_EO_IR_Mode_TRACKING (1)

/* Enum type */
typedef ECOA__uint8 demo1B__T_Radar_Mode;
#define demo1B__T_Radar_Mode_NONE (0)
#define demo1B__T_Radar_Mode_GMTI (1)
#define demo1B__T_Radar_Mode_SAR (2)

/* Enum type */
typedef ECOA__uint8 demo1B__T_SVI;
#define demo1B__T_SVI_LOW_RATE (0)
#define demo1B__T_SVI_HIGHT_RATE (1)

/* Simple type, min is 0, max is 4294967295 */
typedef ECOA__uint32 demo1B__T_Tactical_Item_ID;
#define demo1B__T_Tactical_Item_ID_minRange (0)
#define demo1B__T_Tactical_Item_ID_maxRange (4294967295)

/* Simple type, min is -3.402823466e+38, max is 3.402823466e+38, units are radian */
typedef ECOA__float32 demo1B__T_Angle;
#define demo1B__T_Angle_minRange (-3.402823466e+38)
#define demo1B__T_Angle_maxRange (3.402823466e+38)

/* Simple type, min is -3.402823466e+38, max is 3.402823466e+38, units are metre */
typedef ECOA__float32 demo1B__T_Length;
#define demo1B__T_Length_minRange (-3.402823466e+38)
#define demo1B__T_Length_maxRange (3.402823466e+38)

/* Simple type, min is -3.402823466e+38, max is 3.402823466e+38, units are metre/second */
typedef ECOA__float32 demo1B__T_Speed;
#define demo1B__T_Speed_minRange (-3.402823466e+38)
#define demo1B__T_Speed_maxRange (3.402823466e+38)

/* Simple type, min is -3.402823466e+38, max is 3.402823466e+38, units are radian/second */
typedef ECOA__float32 demo1B__T_AngularSpeed;
#define demo1B__T_AngularSpeed_minRange (-3.402823466e+38)
#define demo1B__T_AngularSpeed_maxRange (3.402823466e+38)

/* Simple type, min is -3.402823466e+38, max is 3.402823466e+38, units are Throttle_Setting */
typedef ECOA__float32 demo1B__T_SVIPower;
#define demo1B__T_SVIPower_minRange (-3.402823466e+38)
#define demo1B__T_SVIPower_maxRange (3.402823466e+38)

/* Simple type, min is -3.402823466e+38, max is 3.402823466e+38, units are squaremetre */
typedef ECOA__float32 demo1B__T_Surface;
#define demo1B__T_Surface_minRange (-3.402823466e+38)
#define demo1B__T_Surface_maxRange (3.402823466e+38)

/* Record type */
typedef struct
{
   demo1B__T_Angle Latitude;
   demo1B__T_Angle Longitude;
} demo1B__T_2D_Position;

/* Record type */
typedef struct
{
   demo1B__T_Angle Latitude;
   demo1B__T_Angle Longitude;
   demo1B__T_Length Height;
} demo1B__T_3D_Position;

/* Simple type, min is -9223372036854775807, max is 9223372036854775807, units are nanoseconds */
typedef ECOA__int64 demo1B__T_Time;
#define demo1B__T_Time_minRange (-9223372036854775807)
#define demo1B__T_Time_maxRange (9223372036854775807)

/* Record type */
typedef struct
{
   demo1B__T_3D_Position Location;
   demo1B__T_Time Time;
} demo1B__T_Waypoint;

/* Record type */
typedef struct
{
   demo1B__T_AngularSpeed Turn_Rate;
   demo1B__T_Speed Climb_Rate;
   demo1B__T_SVIPower Power;
} demo1B__T_AV_Control;

/* Record type */
typedef struct
{
   demo1B__T_3D_Position Location;
   demo1B__T_Speed Airspeed;
   demo1B__T_Angle Heading;
   demo1B__T_SVIPower Power;
} demo1B__T_AV_State;

/* Record type */
typedef struct
{
   demo1B__T_Tactical_Item_ID Tactical_Item_ID;
   demo1B__T_3D_Position Location;
   ECOA__boolean8 Is_Valid;
} demo1B__T_Target_Position;

/* Record type */
typedef struct
{
   demo1B__T_3D_Position Location;
   demo1B__T_Speed Air_Speed;
   demo1B__T_Angle Heading;
   ECOA__boolean8 Is_Valid;
} demo1B__T_State_Vector;

/* Record type */
typedef struct
{
   demo1B__T_Commanded_Power_State Power_State;
   demo1B__T_Align_State Align_State;
   demo1B__T_Readiness_State Readiness_State;
} demo1B__T_Weapon_Status;

/* Record type */
typedef struct
{
   demo1B__T_3D_Position Centre;
   demo1B__T_Length Radius;
} demo1B__T_Weapon_Basket;

/* Record type */
typedef struct
{
   demo1B__T_Tactical_Item_ID Tactical_Item_ID;
   ECOA__boolean8 Is_Valid;
   demo1B__T_3D_Position Location;
   demo1B__T_Speed Radial_Speed;
   demo1B__T_Surface RCS;
} demo1B__T_Tactical_Item;

/* Array type */
#define demo1B__T_Tactical_List_MAXSIZE 6
typedef struct
{
   ECOA__uint32 current_size;
   demo1B__T_Tactical_Item data[demo1B__T_Tactical_List_MAXSIZE];
} demo1B__T_Tactical_List;

/* Array type */
#define demo1B__T_ImageBuffer_MAXSIZE 262144
typedef struct
{
   ECOA__uint32 current_size;
   ECOA__uint8 data[demo1B__T_ImageBuffer_MAXSIZE];
} demo1B__T_ImageBuffer;

/* Record type */
typedef struct
{
   demo1B__T_3D_Position Center_Position;
   demo1B__T_3D_Position TopLeftCorner_Position;
} demo1B__T_SAR_Map_Parameters;

/* Record type */
typedef struct
{
   demo1B__T_SAR_Map_Parameters Parameters;
   demo1B__T_ImageBuffer Image;
} demo1B__T_SAR_Map;


#if defined(__cplusplus)
}
#endif /* __cplusplus */

#endif  /* DEMO1B_H */
