/*
 * CommonKLV.h
 *
 *  Created on: Feb 22, 2013
 *      Author: FCAS_User
 *
 *  $Id: CommonKLV.h,v 2.0 2017/08/02 15:38:06 ksappleb Exp $
 */

#ifndef COMMONKLV_H_
#define COMMONKLV_H_

#if defined(__cplusplus)
extern "C" {
#endif /* __cplusplus */

/* Define the KLV key enumerations */

#define KLV_KEY_ECOA_TIME_TYPE                          (0x00 | 0x00)   /* Generic */
#define KLV_KEY_ECOA_STATION_ID                         (0x00 | 0x01)
#define KLV_KEY_ECOA_SENSOR_ID                          (0x00 | 0x02)
#define KLV_KEY_ECOA_HEALTH                             (0x00 | 0x03)
#define KLV_KEY_ECOA_FAILURE_DESCRIPTION                (0x00 | 0x04)

#define KLV_KEY_ECOA_XXXXXXXXXXXXXXXX                   (0x20 | 0x00)   /* Sensor Command / Control */
#define KLV_KEY_ECOA_SENSOR_C2_PARK                     (0x20 | 0x01)
#define KLV_KEY_ECOA_SENSOR_C2_SENSOR_ANGLE             (0x20 | 0x02)
#define KLV_KEY_ECOA_SENSOR_C2_NAVIGATION_ANGLE         (0x20 | 0x03)
#define KLV_KEY_ECOA_SENSOR_C2_POINT                    (0x20 | 0x04)
#define KLV_KEY_ECOA_SENSOR_C2_RATE                     (0x20 | 0x05)
#define KLV_KEY_ECOA_SENSOR_C2_FOCAL_LENGTH             (0x20 | 0x06)
#define KLV_KEY_ECOA_SENSOR_C2_DIGITAL_ZOOM_INDEX       (0x20 | 0x07)
#define KLV_KEY_ECOA_SENSOR_C2_DIGITAL_ZOOM_STEP        (0x20 | 0x08)
#define KLV_KEY_ECOA_SENSOR_C2_DIGITAL_ZOOM_RATIO       (0x20 | 0x09)
#define KLV_KEY_ECOA_SENSOR_C2_OPTICAL_ZOOM_INDEX       (0x20 | 0x0A)
#define KLV_KEY_ECOA_SENSOR_C2_OPTICAL_ZOOM_STEP        (0x20 | 0x0B)
#define KLV_KEY_ECOA_SENSOR_C2_OPTICAL_ZOOM_RATIO       (0x20 | 0x0C)
#define KLV_KEY_ECOA_SENSOR_C2_FOCUS_POSITION           (0x20 | 0x0D)
#define KLV_KEY_ECOA_SENSOR_C2_FOCUS_STEP               (0x20 | 0x0E)
#define KLV_KEY_ECOA_SENSOR_C2_GEO_FOCUS                (0x20 | 0x0F)
#define KLV_KEY_ECOA_SENSOR_C2_IR_POLARITY              (0x20 | 0x10)
#define KLV_KEY_ECOA_SENSOR_C2_IR_CALIBRATION           (0x20 | 0x11)
#define KLV_KEY_ECOA_SENSOR_C2_Y_PITCH                  (0x20 | 0x12)
#define KLV_KEY_ECOA_SENSOR_C2_Z_PITCH                  (0x20 | 0x13)
#define KLV_KEY_ECOA_SENSOR_C2_APERTURE                 (0x20 | 0x14)
#define KLV_KEY_ECOA_SENSOR_C2_EXPOSURE_TIME            (0x20 | 0x15)
#define KLV_KEY_ECOA_SENSOR_C2_QUALTIY                  (0x20 | 0x16)
#define KLV_KEY_ECOA_SENSOR_C2_FOCUS_MODE               (0x20 | 0x17)
#define KLV_KEY_ECOA_SENSOR_C2_RADAR_MODE               (0x20 | 0x18)
#define KLV_KEY_ECOA_SENSOR_C2_RADAR_RANGE              (0x20 | 0x19)
#define KLV_KEY_ECOA_SENSOR_C2_RADAR_SCAN_WIDTH         (0x20 | 0x1A)
#define KLV_KEY_ECOA_SENSOR_C2_RADAR_SCAN_MODE          (0x20 | 0x1B)
#define KLV_KEY_ECOA_SENSOR_C2_RADAR_SCAN_BARS          (0x20 | 0x1C)
#define KLV_KEY_ECOA_SENSOR_C2_IR_CUT_FILTER            (0x20 | 0x1D)
#define KLV_KEY_ECOA_SENSOR_C2_SHUTTER_SPEED            (0x20 | 0x1E)

#define KLV_KEY_ECOA_SENSOR_DATA_SENSOR_CLASS           (0x40 | 0x00)   /* Sensor Data */
#define KLV_KEY_ECOA_SENSOR_DATA_DATA_CLASS             (0x40 | 0x01)
#define KLV_KEY_ECOA_SENSOR_DATA_COMPRESSION_CLASS      (0x40 | 0x02)
#define KLV_KEY_ECOA_SENSOR_DATA_KEY_FRAME              (0x40 | 0x03)
#define KLV_KEY_ECOA_SENSOR_DATA_REAL_TIME              (0x40 | 0x04)
#define KLV_KEY_ECOA_SENSOR_DATA_IMAGE_ID               (0x40 | 0x05)
#define KLV_KEY_ECOA_SENSOR_DATA_SUB_IMAGE_ID           (0x40 | 0x06)
#define KLV_KEY_ECOA_SENSOR_DATA_FRAME_ID               (0x40 | 0x07)
#define KLV_KEY_ECOA_SENSOR_DATA_SIZE                   (0x40 | 0x08)
#define KLV_KEY_ECOA_SENSOR_DATA_WIDTH                  (0x40 | 0x09)
#define KLV_KEY_ECOA_SENSOR_DATA_HEIGHT                 (0x40 | 0x0A)
#define KLV_KEY_ECOA_SENSOR_DATA_DEPTH                  (0x40 | 0x0B)
#define KLV_KEY_ECOA_SENSOR_DATA_DATA_FORMAT            (0x40 | 0x0C)
#define KLV_KEY_ECOA_SENSOR_DATA_BITS_PER_SAMPLE        (0x40 | 0x0D)
#define KLV_KEY_ECOA_SENSOR_DATA_SIGHTLINE_POSITION     (0x40 | 0x0E)
#define KLV_KEY_ECOA_SENSOR_DATA_SENSOR_POSITION        (0x40 | 0x0F)
#define KLV_KEY_ECOA_SENSOR_DATA_SENSOR_ORIENTATION     (0x40 | 0x10)
#define KLV_KEY_ECOA_SENSOR_DATA_FOOTPRINT              (0x40 | 0x11)
#define KLV_KEY_ECOA_SENSOR_DATA_FOCAL_LENGTH           (0x40 | 0x12)
#define KLV_KEY_ECOA_SENSOR_DATA_IR_POLARITY            (0x40 | 0x13)
#define KLV_KEY_ECOA_SENSOR_DATA_Y_PITCH                (0x40 | 0x14)
#define KLV_KEY_ECOA_SENSOR_DATA_Z_PITCH                (0x40 | 0x15)

#define KLV_KEY_ECOA_TRACK_DATA_IS_TRACK                (0x60 | 0x00)   /* Track Data */
#define KLV_KEY_ECOA_TRACK_DATA_TRACK_ID                (0x60 | 0x01)
#define KLV_KEY_ECOA_TRACK_DATA_CLASS                   (0x60 | 0x02)
#define KLV_KEY_ECOA_TRACK_DATA_ENVIRONMENT             (0x60 | 0x03)
#define KLV_KEY_ECOA_TRACK_DATA_ALLEGIANCE              (0x60 | 0x04)
#define KLV_KEY_ECOA_TRACK_DATA_IDENTITY                (0x60 | 0x05)
#define KLV_KEY_ECOA_TRACK_DATA_TRACK_POSITION          (0x60 | 0x06)
#define KLV_KEY_ECOA_TRACK_DATA_TRACK_POLAR_POSITION    (0x60 | 0x07)
#define KLV_KEY_ECOA_TRACK_DATA_RANGE_RATE              (0x60 | 0x08)
#define KLV_KEY_ECOA_TRACK_DATA_VELOCITY                (0x60 | 0x09)
#define KLV_KEY_ECOA_TRACK_DATA_SIZE                    (0x60 | 0x0A)
#define KLV_KEY_ECOA_TRACK_DATA_THREAT_RANGE            (0x60 | 0x0B)
#define KLV_KEY_ECOA_TRACK_DATA_EMCON_LEVEL             (0x60 | 0x0C)
#define KLV_KEY_ECOA_TRACK_DATA_COVARIANCE              (0x60 | 0x0D)
#define KLV_KEY_ECOA_TRACK_DATA_NUMBER_OF_TRACKS        (0x60 | 0x0E)

#define KLV_KEY_ECOA_SENSOR_STATUS_MODE                 (0x80 | 0x00)   /* Sensor Status */
#define KLV_KEY_ECOA_SENSOR_STATUS_SENSOR_POSITION      (0x80 | 0x01)
#define KLV_KEY_ECOA_SENSOR_STATUS_SENSOR_ORIENTATION   (0x80 | 0x02)
#define KLV_KEY_ECOA_SENSOR_STATUS_PLATFORM_ORIENTATION (0x80 | 0x03)
#define KLV_KEY_ECOA_SENSOR_STATUS_SENSOR_ANGLES        (0x80 | 0x04)
#define KLV_KEY_ECOA_SENSOR_STATUS_SENSOR_RANGE         (0x80 | 0x05)
#define KLV_KEY_ECOA_SENSOR_STATUS_TARGET_POSITION      (0x80 | 0x06)
#define KLV_KEY_ECOA_SENSOR_STATUS_SIGHTLINE_POSITION   (0x80 | 0x07)
#define KLV_KEY_ECOA_SENSOR_STATUS_SIGHTLINE_REACHED    (0x80 | 0x08)

#define KLV_KEY_ECOA_SENSOR_STATUS_DAS_C                        (0x80 | 0x09)
#define KLV_KEY_ECOA_SENSOR_STATUS_DAS_TRAINING_MODE            (0x80 | 0x0A)
#define KLV_KEY_ECOA_SENSOR_STATUS_DAS_MISSION_PLANNING         (0x80 | 0x0B)
#define KLV_KEY_ECOA_SENSOR_STATUS_DAS_NAVIGATION               (0x80 | 0x0C)
#define KLV_KEY_ECOA_SENSOR_STATUS_DAS_HOSTILE_FIRE             (0x80 | 0x0D)
#define KLV_KEY_ECOA_SENSOR_STATUS_DAS_LASER_WARNING            (0x80 | 0x0E)
#define KLV_KEY_ECOA_SENSOR_STATUS_DAS_MISSILE_WARNING          (0x80 | 0x0F)
#define KLV_KEY_ECOA_SENSOR_STATUS_DAS_RADAR_WARNING            (0x80 | 0x10)
#define KLV_KEY_ECOA_SENSOR_STATUS_DAS_ELECTRONIC_INTELLIGENCE  (0x80 | 0x11)
#define KLV_KEY_ECOA_SENSOR_STATUS_DAS_DISPENSING               (0x80 | 0x12)
#define KLV_KEY_ECOA_SENSOR_STATUS_DAS_DIRECTED_IR_CM           (0x80 | 0x13)
#define KLV_KEY_ECOA_SENSOR_STATUS_DAS_OMNI_IR_CM               (0x80 | 0x14)
#define KLV_KEY_ECOA_SENSOR_STATUS_DAS_DIRECTED_RF_CM           (0x80 | 0x15)
#define KLV_KEY_ECOA_SENSOR_STATUS_DAS_OMNI_RF_CM               (0x80 | 0x16)

#define KLV_KEY_ECOA_SENSOR_C2_RADAR_ANTENNA_AZIMUTH    (0xA0 | 0x00)
#define KLV_KEY_ECOA_SENSOR_C2_RADAR_ANTENNA_ELEVATION  (0xA0 | 0x01)

/* Define the LSB constants */

#define KLV_LSB_ECOA_PITCH                  (1.0 / 0.0000001)
#define KLV_LSB_ECOA_FOCAL_LENGTH           (pow(2.0, 32.0) / 5.0)
#define KLV_LSB_ECOA_32_BIT_ANGLE           (pow(2.0, 31.0) / M_PI)
#define KLV_LSB_ECOA_32_BIT_ABSOLUTE_ANGLE  (pow(2.0, 32.0) / (2.0 * M_PI))
#define KLV_LSB_ECOA_16_BIT_ANGLE           (pow(2.0, 15.0) / M_PI)
#define KLV_LSB_ECOA_ALTITUDE               (1.0 / 0.5)
#define KLV_LSB_ECOA_RANGE                  (1.0 / 0.5)
#define KLV_LSB_ECOA_RATE                   (1.0 / 0.5)
#define KLV_LSB_ECOA_SIZE                   (1.0 / 0.5)
#define KLV_LSB_ECOA_APERTURE               (1.0 / 0.1)
#define KLV_LSB_ECOA_EXPOSURE_TIME          (1.0 / 0.001)
#define KLV_LSB_ECOA_QUALITY                (1.0 / 0.01)
#define KLV_LSB_ECOA_COVARIANCE             (1.0 / 0.01)

/* KLV types expected by the applications */

typedef struct
{
  ECOA__uint8   KLV_Key;
  ECOA__uint8   KLV_Length;
  ECOA__uint8  *KLV_Value;
}
PACK_STRUCT CommonKLV_Type;

typedef struct
{
  ECOA__uint8   Number_Of_Items;
  ECOA__uint32  Data_Size;
  ECOA__uint32 *Offsets;
}
PACK_STRUCT CommonKLV_Header_Type;

typedef struct
{
  CommonKLV_Header_Type KLV_Header;
  ECOA__uint8          *KLV_Elements;
}
PACK_STRUCT CommonKLV_Message_Type;

typedef ECOA__int32 Common_KLV_Error;
#define Common_KLV_Error_ERROR (-1)
#define Common_KLV_Error_OK (0)

/*************************************************************************************************************/

/* Procedure to get a KLV item at a given index */
Common_KLV_Error CommonKLV_Get_Item_At_Index(ECOA__uint8 klv_index, const CommonKLV_Message_Type *KLV_Data, CommonKLV_Type *KLV_Element);

/* Procedure to get the length of a KLV element */
ECOA__uint32 CommonKLV_Get_Element_Size(const CommonKLV_Type *KLV);

/* Procedure to free a KLV message */
void CommonKLV_Free_KLV_Message(CommonKLV_Message_Type **KLV_Message);

/* Procedure to create a KLV element */
Common_KLV_Error CommonKLV_Create_Element(CommonKLV_Message_Type **KLV_Data, ECOA__uint8 Key, ECOA__uint8 Length, const void *Value);

/* Procedure to add a KLV item */
Common_KLV_Error CommonKLV_Add_Item(CommonKLV_Message_Type **KLV_Data, const CommonKLV_Type *KLV);

/* Procedure to perform a memcpy while ensuring type constraints are not broken */
void CommonKLV_Copy_Data(void *dest, void *src, ECOA__uint32 dest_length, ECOA__uint32 src_length);

/* Procedure to convert the common format KLV data expected by the applications to ECOA format */
void Common__Convert_KLV_Common_To_ECOA(const CommonKLV_Message_Type *KLV,
                                                   BAE__MAI__Mission_System__General__KLV_Header_Type *header,
                                                   BAE__MAI__Mission_System__General__KLV_Data_Array_Type *data);

/* Procedure to convert ECOA format KLV data to the common format expected by the applications */
ECOA__boolean8 Common__Convert_KLV_ECOA_To_Common(const BAE__MAI__Mission_System__General__KLV_Header_Type *header,
                                                   const BAE__MAI__Mission_System__General__KLV_Data_Array_Type *data,
                                                   CommonKLV_Message_Type **KLV);

/* Procedure to get a key for a parameter string */
ECOA__boolean8 CommonKLV_Get_Key_For_String(char *Name, ECOA__uint8 Length, ECOA__uint8 *key);

/*************************************************************************************************************/

#if defined(__cplusplus)
}
#endif /* __cplusplus */

#endif /* COMMONKLV_H_ */
