/*
 * ECOS Demo1B HMI Pair class
 * 
 * Might be a lat/long position, an x/y position, or whatever...
 * 
 * K S Appleby  March 2012
 * 
 * $Id: Pair.c,v 2.0 2017/08/02 15:38:06 ksappleb Exp $
 */

#include <stdio.h>
#include <string.h>
#include <libxml/tree.h>
#include "Pair.h"

/**********************************************************************************
 * Private operations
 */

/* None */

/**********************************************************************************
 * Public operations
 */

char* pairToXML( Pair pair, char* aLabel, char* bLabel, char* buf )
{
	if( buf != NULL )
		sprintf( buf, "<%s>%lg</%s><%s>%lg</%s>\n", aLabel, pair.a, aLabel, bLabel, pair.b, bLabel );
	return buf;
}

char* pairToString( Pair pair, char* aLabel, char* bLabel, char* buf )
{
	if( buf != NULL )
		sprintf( buf, "( %lg, %lg )\n", pair.a, pair.b );
	return buf;
}

void  pairFillFromXML( Pair* pair, xmlDocPtr pDoc, xmlNodePtr pNode, char* aLabel, char* bLabel )
{
	xmlChar*   p;
	xmlNodePtr cur = pNode->xmlChildrenNode;
	do {
		while( cur != NULL && 
			( xmlIsBlankNode( cur ) || strcmp( cur->name, "comment" )==0 )){
			cur = cur->next;
	    }
		if( cur == NULL ) break;
		if( xmlStrcmp( cur->name, (const xmlChar *)aLabel ) == 0 ){
			pair->a = atof( (char*)(p = xmlNodeGetContent( cur ))); xmlFree(p);
		}else
		if( xmlStrcmp( cur->name, (const xmlChar *)bLabel ) == 0 ){
			pair->b = atof( (char*)(p = xmlNodeGetContent( cur ))); xmlFree(p);
		}else{
			fprintf(stderr,"%s: wrong node type (found %s)\n", (pDoc->name ? pDoc->name : "Label"), cur->name );
			break;
		}
		cur = cur->next;
	}while( cur != NULL );
}
