/*
 * ECOS Demo1B HMI Target List class
 * 
 * K S Appleby  March 2012
 * 
 * $Id: Targets.h,v 2.0 2017/08/02 15:38:06 ksappleb Exp $
 */

#ifndef TARGETS_H_
#define TARGETS_H_

#include "Target.h"

typedef struct Targetst *Targets;

Targets      targetsCreate();
void         targetsDestroy( Targets trgts );

unsigned int targetsGetNumTargets( Targets trgts );
Target       targetsGetTarget( Targets trgts, int id );
Target       targetsGetTargetByIndex( Targets trgts, unsigned int indx );

void         targetsAddTarget( Targets trgts, Target trgt );
int          targetsLoadTargets( Targets trgts, char*  uri );

char*        targetsToXML( Targets trgts, char* buf );
char*        targetsToString( Targets trgts, char* buf );

void         targetsFillFromXML( Targets trgts, xmlDocPtr pDoc, xmlNodePtr pNode );

#endif /*TARGETS_H_*/
