/* vxwCompat.c */
/*
 ##############################################################
 # (C) 2015 BAE SYSTEMS
 #
 # ECOA Data Servers Sample - VxWorks compatibility functions
 #
 # $Id: vxwCompat.c,v 2.1 2017/11/06 15:33:32 ksappleb Exp $
 #
 # Part of the BAE Systems, Rochester, ECOA Samples collection
 #
 # Created by K S Appleby, BAE Systems, Airport Works, Rochester, Kent
 #
 # This software is developed for and on behalf of BAE Systems (Operations)
 # Limited, Dassault Aviation, Bull SAS, Thales Systemes Aeroportes,
 # GE Aviation Systems Limited,
 # General Dynamics United Kingdom Limited and Leonardo MW Ltd,
 # and the copyright is owned by BAE Systems (Operations) Limited,
 # Dassault Aviation, Bull SAS, Thales Systemes Aeroportes, 
 # GE Aviation Systems Limited, General Dynamics United Kingdom
 # Limited and Leonardo MW Ltd
 #
 # This software is developed by BAE Systems (Operations)
 # Limited, Electronic Systems, and is the Intellectual
 # Property of BAE Systems (Operations) Limited, Electronic Systems.
 #
 # The information set out in this document is provided solely
 # on an 'as is' basis and the co-developers of this software make
 # no warranties expressed or implied, including no warranties
 # as to completeness, accuracy or fitness for purpose, with respect
 # to any of the information.
 ##############################################################
*/
# include <stdlib.h>
# include <string.h>

char* toLower( const char* s )
{
char *sc = strdup( s ), *ch = sc;
	while( *ch != '\000')
		if( 'A' <= *ch && *ch <= 'Z' )
			*ch = *ch + ( 'a' - 'A' );
	return sc;
}

int strncasecmp( const char* s1, const char* s2, size_t n )
{
	char *s1c = toLower( s1 ), *s2c = toLower( s2 );
	int res = strncmp( s1c, s2c, n );
	free( s1c ); free( s2c );
	return res;
}

